
var index = lunr(function () {
    this.field('body');
    this.ref('url');
});

var documentTitles = {};



documentTitles["gettingstartediosnative.html#getting-started"] = "Getting started";
index.add({
    url: "gettingstartediosnative.html#getting-started",
    title: "Getting started",
    body: "# Getting started  &lt;p class='intro' markdown='1'&gt;Welcome to the Wikitude SDK. This document is designed to help you from your very first steps with the Wikitude SDK all the way through to advanced concepts and examples for developing your augmented reality project.&lt;/p&gt;  "
});

documentTitles["gettingstartediosnative.html#recommended-usage-of-this-documentation"] = "Recommended Usage of this Documentation";
index.add({
    url: "gettingstartediosnative.html#recommended-usage-of-this-documentation",
    title: "Recommended Usage of this Documentation",
    body: "### Recommended Usage of this Documentation  The documentation is arranged in a way to guide you through the various steps in your development process. We recommend  following each of the steps outlined below and reading the documentation in the order displayed.  &lt;div class=\&quot;bigNumbers\&quot; markdown='1'&gt; &lt;div class='number'&gt;1&lt;/div&gt; "
});

documentTitles["gettingstartediosnative.html#setup-your-projectsetupguideiosnativehtml"] = "[Setup your project](setupguideiosnative.html)";
index.add({
    url: "gettingstartediosnative.html#setup-your-projectsetupguideiosnativehtml",
    title: "[Setup your project](setupguideiosnative.html)",
    body: "#### [Setup your project](setupguideiosnative.html) In this section we describe the necessary steps to setup a project in a detailed guide.  &lt;div class='number'&gt;2&lt;/div&gt; "
});

documentTitles["gettingstartediosnative.html#view-the-samplessamplesnativehtml"] = "[View the samples](samplesnative.html)";
index.add({
    url: "gettingstartediosnative.html#view-the-samplessamplesnativehtml",
    title: "[View the samples](samplesnative.html)",
    body: "#### [View the samples](samplesnative.html) All of the included samples are complete iOS projects and apps. Browse through this section and get an idea of what the SDK is capable of. The relevant parts of the samples are described in more detail to highlight the applied concepts and patterns. These examples are designed to help you get off to a great start with the Wikitude SDK.  Viewing samples based on vision based augmented reality requires the corresponding reference images. All of them are available directly in the description of the sample or available as a collection [on this page](targetimages.html), which you can either view on the screen or print. &lt;/div&gt;  "
});

documentTitles["gettingstartediosnative.html#the-wikitude-sdk-augmented-reality-for-your-own-app"] = "The Wikitude SDK - Augmented Reality for your own app";
index.add({
    url: "gettingstartediosnative.html#the-wikitude-sdk-augmented-reality-for-your-own-app",
    title: "The Wikitude SDK - Augmented Reality for your own app",
    body: "### The Wikitude SDK - Augmented Reality for your own app  The Wikitude SDK is a software library and framework for mobile apps used to create augmented reality experiences.   As opposed to the Wikitude SDK - JavaScript API where you define your AR experiences with JavaScript, you will create your AR experiences with ObjC and OpenGL when using the Wikitude Native SDK.   "
});

documentTitles["gettingstartediosnative.html#architecture-of-the-wikitude-sdk"] = "Architecture of the Wikitude SDK";
index.add({
    url: "gettingstartediosnative.html#architecture-of-the-wikitude-sdk",
    title: "Architecture of the Wikitude SDK",
    body: "### Architecture of the Wikitude SDK  ![](images/sdk6_architecture.png)  The image above shows the different components of the Wikitude SDK and possible approaches for creating augmented reality apps. Each of these approaches are based on a certain development environments (IDE) and platforms:  * **Computer Vision Engine:** The computer vision engine is a core component of the Wikitude SDK and used by all platforms. It is not directly accessible, but wrapped either by the Native API or the JavaScript API. * **Wikitude SDK  - Native API:** Provides access to the Wikitude computer vision engine natively for Android (Java) and iOS (ObjC). It also can load plugins via the Wikitude Plugins API.  * **Wikitude SDK  - JavaScript API:** Allows to build augmented reality worlds on basis of HTML and JavaScript. It is available for Android and iOS. The JavaScript API provides access to the functionality of the computer vision engine, location based AR, the Plugins API and dedicated rendering functionality. * **Wikitude SDK  - Plugins API:** An API to connect your own plugins to the Wikitude SDK. (NOTE: Wikitude SDK plugins have nothing to do with the Cordova or Unity Plugin concept.) * **Wikitude SDK  - Cordova Plugin:** On top of the JavaScript API the Cordova plugin allows to use the Wikitude SDK in combination with Apache Cordova. * **Wikitude SDK  - Titanium Module:** On top of the JavaScript API the Titanium module allows to use the Wikitude SDK in combination with Titanium. * **Wikitude SDK  - Unity Plugin:** On top of the Native API the Unity plugin allows to use the Wikitude SDK in combination with Unity. * **Wikitude SDK  - Xamarin Component:** On top of the JavaScript API the Xamarin component allows to use the Wikitude SDK in combination with Xamarin.   "
});

documentTitles["gettingstartediosnative.html#the-wikitude-developer-portal"] = "The Wikitude Developer Portal";
index.add({
    url: "gettingstartediosnative.html#the-wikitude-developer-portal",
    title: "The Wikitude Developer Portal",
    body: "### The Wikitude Developer Portal The Wikitude Developer Section should be your first stop when you have specific development related questions. The portal hosts a very active &lt;a href=\&quot;https://support.wikitude.com/support/home\&quot; target=\&quot;_top\&quot;&gt;Developer Community Forum&lt;/a&gt; where Wikitude staff members are constantly assisting other developers with helpful tips and advice. You can find How-To's and a constantly evolving FAQ section there as well.  "
});

documentTitles["gettingstartediosnative.html#feedback-and-contact"] = "Feedback and Contact";
index.add({
    url: "gettingstartediosnative.html#feedback-and-contact",
    title: "Feedback and Contact",
    body: "### Feedback and Contact We are always interested in your feedback and suggestions how we can improve this documentation. Please use the &lt;a href=\&quot;http://www.wikitude.com/contact\&quot; target=\&quot;_top\&quot;&gt;contact form&lt;/a&gt; on our website or visit us on &lt;a href=\&quot;https://plus.google.com/103004921345651739447/\&quot; target=\&quot;_top\&quot;&gt;Google+&lt;/a&gt;,  &lt;a href=\&quot;https://www.facebook.com/WIKITUDE\&quot; target=\&quot;_top\&quot;&gt;Facebook&lt;/a&gt; or &lt;a href=\&quot;https://www.twitter.com/wikitude\&quot; target=\&quot;_top\&quot;&gt;Twitter&lt;/a&gt;. "
});



documentTitles["setupguideiosnative.html#setup-guide-ios-native-api"] = "Setup Guide iOS Native API";
index.add({
    url: "setupguideiosnative.html#setup-guide-ios-native-api",
    title: "Setup Guide iOS Native API",
    body: "## Setup Guide iOS Native API  There are only a few steps necessary to add the Wikitude Native SDK to your existing iOS application. This guide will explain them in detail. In general the steps are  * Adding the Wikitude Native SDK .framework to a Xcode project * Using the main classes to create your augmented reality experiences  "
});

documentTitles["setupguideiosnative.html#project-setup"] = "Project Setup";
index.add({
    url: "setupguideiosnative.html#project-setup",
    title: "Project Setup",
    body: "## Project Setup   "
});

documentTitles["setupguideiosnative.html#load-your-xcode-project"] = "Load your Xcode project";
index.add({
    url: "setupguideiosnative.html#load-your-xcode-project",
    title: "Load your Xcode project",
    body: "### Load your Xcode project The first step is to open an exiting Xcode project. If there is no project already created, do so using the Xcode project configurator.  "
});

documentTitles["setupguideiosnative.html#adding-the-wikitude-sdk-framework"] = "Adding the Wikitude SDK Framework";
index.add({
    url: "setupguideiosnative.html#adding-the-wikitude-sdk-framework",
    title: "Adding the Wikitude SDK Framework",
    body: "### Adding the Wikitude SDK Framework To keep things clear, you should copy the Wikitude Native SDK .framework into your Xcode project structure. Having it somewhere else on your machine might lead to confusion when updating to a newer version of the Wikitude Native SDK.  After the .framework was copied, it can be added as 'Embedded Binaries'.  ![ ](images/ios_native_sdk__embedded_swift_content.png)  Because the Wikitude Native SDK will fully support Swift, a build setting has to be changed in order to package Swift Standard Libraries into the final application package. ![ ](images/ios_native_sdk__embedded_binaries.png)  The project is now fully configured to use the Wikitude Native SDK.    "
});

documentTitles["setupguideiosnative.html#using-the-wikitude-native-sdk-in-your-application"] = "Using the Wikitude Native SDK in your Application";
index.add({
    url: "setupguideiosnative.html#using-the-wikitude-native-sdk-in-your-application",
    title: "Using the Wikitude Native SDK in your Application",
    body: "### Using the Wikitude Native SDK in your Application After the setup steps are completed, the Wikitude Native SDK is ready to be used within an iOS application.  The Wikitude Native SDK comes with an umbrella header that has to be included in your corresponding source files. The file is called `WikitudeNativeSDK.h` and can be imported by calling `#import &lt;WikitudeNativeSDK/WikitudeNativeSDK.h&gt;`  The main class to work with is `WTWikitudeNativeSDK`. It's the central point for creating trackers, to obtain an already configured rendering component or to control camera related settings.  The Wikitude Native SDK can be used in trial mode without any license, but to remove the watermark, a valid license has to be set using the `-setLicenseKey` method.  "
});

documentTitles["setupguideiosnative.html#application-lifecycle"] = "Application Lifecycle";
index.add({
    url: "setupguideiosnative.html#application-lifecycle",
    title: "Application Lifecycle",
    body: "#### Application Lifecycle To integrate the Wikitude Native SDK into the application lifecycle, use the `-start:completion` and `-stop` methods of `WTWikitudeNativeSDK`. A good place to call them is e.g. a `UIViewControllers` `-viewWillAppear:` and `-viewWillDisappear:`.  To refine the startup phase, the `WTStartupConfiguration` object can be used which is the first arguments in first block parameter of `-start:completion:`. The second block parameter can be used to check if the Wikitude Native SDK could actually start with the given configuration on the current device. Use the `isRunning` parameter to determine the run state and e.g. create tracker in this block. The following listening demonstrates this: ```objc     [self.wikitudeSDK start:nil completion:^(BOOL isRunning, NSError * __nonnull error) {         if ( !isRunning ) {             NSLog(@\&quot;Wikitude SDK is not running. Reason: %@\&quot;, [error localizedDescription]);         }         else         {             __weak typeof(self) weakSelf = self;                          NSURL *imageTrackerResourceURL = [[NSBundle mainBundle] URLForResource:@\&quot;magazine\&quot; withExtension:@\&quot;wtc\&quot; subdirectory:@\&quot;Assets\&quot;];             self.targetCollectionResource = [self.wikitudeSDK.trackerManager createTargetCollectionResourceFromURL:imageTrackerResourceURL completion:^(BOOL success, NSError * _Nullable error) {                 if ( !success )                 {                     NSLog(@\&quot;Failed to load URL resource. Reason: %@\&quot;, [error localizedDescription]);                 }                 else                 {                     weakSelf.imageTracker = [weakSelf.wikitudeSDK.trackerManager createImageTrackerFromTargetCollectionResource:weakSelf.targetCollectionResource delegate:weakSelf configuration:nil];                 }             }];         }     }]; ```  "
});

documentTitles["setupguideiosnative.html#error-handling"] = "Error Handling";
index.add({
    url: "setupguideiosnative.html#error-handling",
    title: "Error Handling",
    body: "#### Error Handling The Wikitude Native SDK calls the `WTWikitudeNativeSDK` delegate method `-wikitudeNativeSDK: didEncounterInternalError:` as soon as an internally inconsistent state was detected and parts of the SDK might stop working as expected. This is especially helpful while developing the application and not so much for end user notifications.  "
});

documentTitles["setupguideiosnative.html#trackers-camera-and-rendering"] = "Trackers, Camera and Rendering";
index.add({
    url: "setupguideiosnative.html#trackers-camera-and-rendering",
    title: "Trackers, Camera and Rendering",
    body: "#### Trackers, Camera and Rendering How trackers, the camera controls and rendering can be used, will be explained in the example part of this documentation. Each feature will be explained in detail through a real usage example.  "
});



documentTitles["supporteddevicesiosnative.html#supported-ios-devices"] = "Supported iOS Devices";
index.add({
    url: "supporteddevicesiosnative.html#supported-ios-devices",
    title: "Supported iOS Devices",
    body: "## Supported iOS Devices  Wikitude SDK (Native API) is running on devices fulfilling the following requirements:  &lt;table&gt; &lt;tr&gt; &lt;th style=\&quot;width:33%;\&quot;&gt;Sensor-based AR (Geo-AR)&lt;/th&gt; &lt;th style=\&quot;width:33%;\&quot;&gt;Image recognition and tracking&lt;/th&gt; &lt;th style=\&quot;width:33%;\&quot;&gt;Instant tracking&lt;/th&gt; &lt;/tr&gt;  &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;a name=\&quot;supporteddevicesios\&quot;&gt;&lt;/a&gt;&lt;h4&gt;iOS (Native&amp;nbsp;API)&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  	&lt;li&gt;not available&lt;/li&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;   &lt;li&gt;Devices running iOS 8.0  and up&lt;/li&gt;   &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;li&gt;Devices with a capable CPU (minimum Apple A4 SoC) e.g.&lt;/li&gt;  &lt;ul&gt;&lt;li&gt;iPhone 4 or newer&lt;/li&gt;  &lt;li&gt;iPad2 or newer&lt;/li&gt;  &lt;li&gt;iPod Touch 5th gen&lt;/li&gt;&lt;/ul&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;   &lt;li&gt;Devices running iOS 8.0  and up&lt;/li&gt;   &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;li&gt;Devices with a capable CPU (minimum Apple A4 SoC) e.g.&lt;/li&gt;  &lt;ul&gt;&lt;li&gt;iPhone 4 or newer&lt;/li&gt;  &lt;li&gt;iPad2 or newer&lt;/li&gt;  &lt;li&gt;iPod Touch 5th gen&lt;/li&gt;&lt;/ul&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt;  &lt;/table&gt;  Requirements for other operating systems and platforms are listed in [this overview](supporteddevices.html). "
});



documentTitles["supporteddevices.html#supported-devices"] = "Supported Devices";
index.add({
    url: "supporteddevices.html#supported-devices",
    title: "Supported Devices",
    body: "#### Supported Devices Wikitude SDK is running on devices fulfilling the following requirements:  &lt;table&gt; &lt;tr&gt; &lt;th style=\&quot;width:33%;\&quot;&gt;Sensor-based AR (Geo-AR)&lt;/th&gt; &lt;th style=\&quot;width:33%;\&quot;&gt;Image recognition and tracking&lt;/th&gt; &lt;th style=\&quot;width:33%;\&quot;&gt;Instant tracking&lt;/th&gt; &lt;/tr&gt;  &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;h4&gt;&lt;a name=\&quot;supporteddevicesandroid\&quot;&gt;&lt;/a&gt;Android&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Android 4.0.3+ (API Level 15+)&lt;/li&gt;  &lt;li&gt;Compass&lt;/li&gt;  &lt;li&gt;GPS and / or network positioning&lt;/li&gt;  &lt;li&gt;Accelerometer&lt;/li&gt;  &lt;li&gt;&lt;a href=\&quot;http://developer.android.com/guide/practices/screens_support.html\&quot; target=\&quot;_top\&quot;&gt;High resolution devices (hdpi)&lt;/a&gt;&lt;/li&gt;  &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;li&gt;&lt;a href=\&quot;http://developer.android.com/guide/topics/graphics/opengl.html\&quot; target=\&quot;_top\&quot;&gt;OpenGL 2.0&lt;/a&gt; (or newer)&lt;/li&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Android 4.0.3+ (API Level 15+)&lt;/li&gt;   &lt;li&gt;&lt;a href=\&quot;http://developer.android.com/guide/practices/screens_support.html\&quot; target=\&quot;_top\&quot;&gt;High resolution devices (hdpi)&lt;/a&gt;&lt;/li&gt;    &lt;li&gt;Rear-facing camera&lt;/li&gt;    &lt;li&gt;&lt;a href=\&quot;http://developer.android.com/guide/topics/graphics/opengl.html\&quot; target=\&quot;_top\&quot;&gt;OpenGL 2.0&lt;/a&gt; (or newer)&lt;/li&gt;  &lt;li&gt;Devices with a capable CPU carmv7a with NEON support or armv8a) e.g.&lt;/li&gt;  &lt;ul&gt;&lt;li&gt;Samsung Galaxy S2 or newer&lt;/li&gt;  &lt;li&gt;Nexus 4 or newer&lt;/li&gt;  &lt;li&gt;Nexus 10 (2012) or newer&lt;/li&gt; &lt;/ul&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;   &lt;li&gt;Android 4.0.3+ (API Level 15+)&lt;/li&gt;   &lt;li&gt;Compass&lt;/li&gt;   &lt;li&gt;Accelerometer&lt;/li&gt;   &lt;li&gt;&lt;a href=\&quot;http://developer.android.com/guide/practices/screens_support.html\&quot; target=\&quot;_top\&quot;&gt;High resolution devices (hdpi)&lt;/a&gt;&lt;/li&gt;   &lt;li&gt;Rear-facing camera&lt;/li&gt;   &lt;li&gt;&lt;a href=\&quot;http://developer.android.com/guide/topics/graphics/opengl.html\&quot; target=\&quot;_top\&quot;&gt;OpenGL 2.0&lt;/a&gt; (or newer)&lt;/li&gt;   &lt;li&gt;Devices with a quad-core CPU (armv7a with NEON support or armv8a) e.g.&lt;/li&gt;   &lt;ul&gt;&lt;li&gt;Samsung Galaxy S3 or newer&lt;/li&gt;    &lt;li&gt;Nexus 4 or newer&lt;/li&gt;    &lt;li&gt;Nexus 7 (2013)&lt;/li&gt;   &lt;/ul&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;a name=\&quot;supporteddevicesandroid\&quot;&gt;&lt;/a&gt;&lt;h4&gt;Android (Native&amp;nbsp; API)&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  	&lt;li&gt;not available&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Android 4.0.3+ (API Level 15+)&lt;/li&gt;   &lt;li&gt;&lt;a href=\&quot;http://developer.android.com/guide/practices/screens_support.html\&quot; target=\&quot;_top\&quot;&gt;High resolution devices (hdpi)&lt;/a&gt;&lt;/li&gt;    &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;li&gt;Devices with a capable CPU (armv7a with NEON support or armv8a) e.g.&lt;/li&gt;  &lt;ul&gt;&lt;li&gt;Samsung Galaxy S2 or newer&lt;/li&gt;  &lt;li&gt;Nexus 4 or newer&lt;/li&gt;  &lt;li&gt;Nexus 10 (2012) or newer&lt;/li&gt; &lt;/ul&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;   &lt;li&gt;Android 4.0.3+ (API Level 15+)&lt;/li&gt;   &lt;li&gt;Compass&lt;/li&gt;   &lt;li&gt;Accelerometer&lt;/li&gt;   &lt;li&gt;&lt;a href=\&quot;http://developer.android.com/guide/practices/screens_support.html\&quot; target=\&quot;_top\&quot;&gt;High resolution devices (hdpi)&lt;/a&gt;&lt;/li&gt;   &lt;li&gt;Rear-facing camera&lt;/li&gt;   &lt;li&gt;Devices with a quad-core CPU (armv7a with NEON support or armv8a) e.g.&lt;/li&gt;   &lt;ul&gt;&lt;li&gt;Samsung Galaxy S3 or newer&lt;/li&gt;    &lt;li&gt;Nexus 4 or newer&lt;/li&gt;    &lt;li&gt;Nexus 7 (2013)&lt;/li&gt;   &lt;/ul&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;a name=\&quot;supporteddevicesepson\&quot;&gt;&lt;/a&gt;&lt;h4&gt;Epson&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Epson Moverio BT-200&lt;/li&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Epson Moverio BT-200&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Epson Moverio BT-200&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt;  &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;a name=\&quot;supporteddevicesepson\&quot;&gt;&lt;/a&gt;&lt;h4&gt;ODG&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;ODG R-7&lt;/li&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;ODG R-7&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;ODG R-7&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt;  &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;a name=\&quot;supporteddevicesios\&quot;&gt;&lt;/a&gt;&lt;h4&gt;iOS (JavaScript API)&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Devices running iOS 8.3  and up&lt;/li&gt;  &lt;li&gt;Compass&lt;/li&gt;  &lt;li&gt;GPS and / or network positioning&lt;/li&gt;  &lt;li&gt;Accelerometer&lt;/li&gt;  &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;   &lt;li&gt;Devices running iOS 8.3  and up&lt;/li&gt;   &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;li&gt;Devices with a capable CPU (minimum Apple A4 SoC) e.g.&lt;/li&gt;  &lt;ul&gt;&lt;li&gt;iPhone 4 or newer&lt;/li&gt;  &lt;li&gt;iPad2 or newer&lt;/li&gt;  &lt;li&gt;iPod Touch (5th gen) or newer&lt;/li&gt;&lt;/ul&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;   &lt;li&gt;Devices running iOS 8.3  and up&lt;/li&gt;   &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;li&gt;Devices with a capable CPU (minimum Apple A6) e.g.&lt;/li&gt;  &lt;ul&gt;&lt;li&gt;iPhone 5 or newer&lt;/li&gt;  &lt;li&gt;iPad (4th gen) or newer&lt;/li&gt;  &lt;li&gt;iPod Touch (6th gen)&lt;/li&gt;&lt;/ul&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt;  &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;a name=\&quot;supporteddevicesios\&quot;&gt;&lt;/a&gt;&lt;h4&gt;iOS (Native&amp;nbsp;API)&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  	&lt;li&gt;not available&lt;/li&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;   &lt;li&gt;Devices running iOS 8.0  and up&lt;/li&gt;   &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;li&gt;Devices with a capable CPU (minimum Apple A4 SoC) e.g.&lt;/li&gt;  &lt;ul&gt;&lt;li&gt;iPhone 4 or newer&lt;/li&gt;  &lt;li&gt;iPad2 or newer&lt;/li&gt;  &lt;li&gt;iPod Touch 5th gen&lt;/li&gt;&lt;/ul&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;   &lt;li&gt;Devices running iOS 8.0  and up&lt;/li&gt;   &lt;li&gt;Rear-facing camera&lt;/li&gt;  &lt;li&gt;Devices with a capable CPU (minimum Apple A4 SoC) e.g.&lt;/li&gt;  &lt;ul&gt;&lt;li&gt;iPhone 4 or newer&lt;/li&gt;  &lt;li&gt;iPad2 or newer&lt;/li&gt;  &lt;li&gt;iPod Touch 5th gen&lt;/li&gt;&lt;/ul&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt;  &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;a name=\&quot;supporteddevicesepson\&quot;&gt;&lt;/a&gt;&lt;h4&gt;ODG&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;ODG R-7&lt;/li&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;ODG R-7&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;ODG R-7&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt;  &lt;tr&gt; &lt;td colspan=\&quot;3\&quot;&gt;&lt;a name=\&quot;supporteddevicesvuzix\&quot;&gt;&lt;/a&gt;&lt;h4&gt;Vuzix&lt;/h4&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Vuzix M100&lt;/li&gt;  &lt;/ul&gt;  &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Vuzix M100&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;td style=\&quot;vertical-align:top;\&quot;&gt;  &lt;ul&gt;  &lt;li&gt;Vuzix M100&lt;/li&gt;  &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt;&lt;/table&gt; "
});



documentTitles["triallicense.html#how-to-obtain-a-free-trial-license"] = "How to obtain a free trial license";
index.add({
    url: "triallicense.html#how-to-obtain-a-free-trial-license",
    title: "How to obtain a free trial license",
    body: "## How to obtain a free trial license  The Wikitude SDK requires a valid license key to be able to run properly. An empty or missing license key will block the augmented reality view from showing any meaningful content. You will see a watermark across the screen with the words `License Key Missing`. All JavaScript API calls will be ignored and not interpreted.  When downloading the Wikitude SDK you will be forwarded to the [license generation page](http://www.wikitude.com/developer/licenses), where a trial license key is automatically generated for you.   ![](images/trial_key_license_page.png)  Copy the key into your app, which will unlock the trial mode of the Wikitude SDK. The trial mode of the Wikitude SDK contains the full feature set of the Wikitude SDK but will show a `Trial` watermark across the screen.  Each trial license key is valid for every application ID on every operating system. You can use the same trial license key in multiple apps.   "
});

documentTitles["triallicense.html#where-should-i-enter-the-license-key"] = "Where should I enter the license key";
index.add({
    url: "triallicense.html#where-should-i-enter-the-license-key",
    title: "Where should I enter the license key",
    body: "## Where should I enter the license key        "
});

documentTitles["triallicense.html#ios-native-api"] = "iOS Native API";
index.add({
    url: "triallicense.html#ios-native-api",
    title: "iOS Native API",
    body: "### iOS Native API To use the Wikitude iOS SDK with a certain license key, use the method `-setLicenseKey:` defined in `WTWikitudeNativeSDK.h` and provide a valid license key.                   "
});



documentTitles["samplesnative.html#examples"] = "Examples";
index.add({
    url: "samplesnative.html#examples",
    title: "Examples",
    body: "# Examples  The following examples should give you an overview of the capabilities offered by the Wikitude SDK. Each sample is capable of running without modifications on all supported platforms.   The Sample App is a fully functional sample project either for Android or iOS. You can easily import it into Android Studio or Xcode and work from there. The user interface is kept very simple and shows a list to select the sample you are interested.      "
});

documentTitles["samplesnative.html#examples-application"] = "Examples Application";
index.add({
    url: "samplesnative.html#examples-application",
    title: "Examples Application",
    body: "### Examples Application  This section describes the `SDKExamples` application in detail and highlights the main features and use-cases of the Wikitude SDK.   Please note that the Xcode projects **deployment target** is set to **iOS 8** and the application has to be deployed to a actual iOS device and **not** the **simulator**.  "
});

documentTitles["samplesnative.html#structure"] = "Structure";
index.add({
    url: "samplesnative.html#structure",
    title: "Structure",
    body: "#### Structure  The `Native Examples` application is structured as a table view where each cell launches an individual example, describing a specific feature of the SDK.   The application uses an `UINavigationViewController` and pushes each example with a dedicated view controller who implements a complete use case. All view controller are grouped together in the `Controller` group. Example specific assets are locates in the `Assets` group. Rendering related classes that are used by multiple examples can be found in `CoreServices` and `Views`.  "
});

documentTitles["samplesnative.html#usage"] = "Usage";
index.add({
    url: "samplesnative.html#usage",
    title: "Usage",
    body: "#### Usage  To run the application, open the Xcode project and click `Run`.    "
});



documentTitles["imagerecognitionnative.html#image-recognition"] = "Image Recognition";
index.add({
    url: "imagerecognitionnative.html#image-recognition",
    title: "Image Recognition",
    body: "## Image Recognition  This example shows how to recognize images in the viewfinder and overlay it with images.   For a better understanding, here are some terms that will be used in the following and other section of this documentation related to vision-based augmented reality.  - **Target**: A 2D target image and its associated extracted data that is used by the tracker to recognize an image.  - **Target Collection**: An archive storing a collection of 2D targets that can be recognized by the tracker. A target collection can hold up to 1000 targets. Target collections are stored as `.wtc` files  - **ImageTracker**: The tracker analyzes the live camera image and detects the 2D targets stored in its associated target collection. Multiple trackers can be created, however only one tracker can be active for recognition at any given time.     &lt;a id=\&quot;SimpleClientTrackingiOS\&quot;&gt;&lt;/a&gt; "
});

documentTitles["imagerecognitionnative.html#simple-2d-client-tracking-ios"] = "Simple 2D Client Tracking iOS";
index.add({
    url: "imagerecognitionnative.html#simple-2d-client-tracking-ios",
    title: "Simple 2D Client Tracking iOS",
    body: "### Simple 2D Client Tracking iOS  In this section we will go through the WTSimpleClientTrackerViewController code, which you can find in the example applications folder `Native Examples/Controller/ClientTracking`. We will discuss general concepts on how to use the Wikitude Native SDK as we go along, please don't skip this sample even if you are only interested in cloud recognition for example.  Please refer to the Setup Guide section of this documentation to find detailed information on how to integrate the Wikitude Native SDK into a Xcode project.  In this example we will use external rendering, for details on how to setup the rendering and the difference between internal and external rendering please read through the section on [rendering](renderingnative.html).  The `WTWikitudeNativeSDK` class is structured to be used in a standard iOS view controller as a model of the MVC pattern. This class is central starting point for anything related to the Wikitude Native SDK. It provides factory methods to create different kinds of tracker and to receive information of those through their delegate objects.  A typical usage would be to have a strong reference to a `WTWikitudeNativeSDK` object in a view controller and to define this view controller to be conform to the `WTWikitudeNativeSDKDelegate` protocol  ```objc @interface WTSimpleClientTrackerViewController () &lt;WTWikitudeNativeSDKDelegate, WTImageTrackerDelegate&gt; ``` The `WTWikitudeNativeSDKDelegate` protocol defines methods that can be used to react on SDK specific events. It is the chosen way to communicate e.g. runtime errors that can not be returned directly from an API call. Such errors might contain information about camera authorization status changes and inconsistent rendering setups.  To receive image tracker information about recognized/tracked or lost targets, this view controller must also conform to the `WTImageTrackerDelegate` protocol. All methods in the mentioned protocol are optionals thus only provide information from the SDK but don't require any action from the application. Additionally this protocol provides information about the loading status of a particular image tracker object.  The next step we will take is create an instance of the `WTWikitudeNativeSDK` class. This is the only object that you have to create manually. All other object will be created by factory methods of the WTWikitudeNativeSDK object.  &lt;div class=\&quot;warning\&quot;&gt;  IMPORTANT: Do not instantiate any other class out of the Wikitude Native SDK other than the `WTWikitudeNativeSDK` manually. All object somehow play together in a well defined manner and that why they are internally controlled by the `WTWikitudeNativeSDK` object and its sub components like `WTTrackerManger` and `WTCaptureDeviceManager`. &lt;/div&gt;  A `WTWikitudeNativeSDK` object can be instantiated at any time and does not depend on any particular application lifecycle event. To integrate internal processes into the hosting application, `-start:completion` and `-stop` are used. These two methods should either be called from `- viewWillAppear: | - viewWillDisappear:` or `-viewDidAppear: | -viewDidDisappear:`. To refine the startup behaviour of the Wikitude Native SDK, the first block parameter of `-start:completion:` contains an already created and setup object of type `WTNativeSDKStartupConfiguration`. Public properties of this object can be used to further define how the Wikitude Native SDK should start e.g. its camera. Typical settings from this object are the camera preset which defines in which resolution the device camera should be started or what's the desired target rendering frame rate. The second block parameter contains a BOOL indicating if the given properties could be taken into account during the final startup phase. If an error occurred, `isRunning` is set to `NO` and the given `NSError` object contains more information about what went wrong.  The second block parameter is also the ideal starting point to create any tracker object from the Wikitude Native SDK if the running state is YES. Image trackers work with target collection resources, that load target collections represented through a .wtc file (Wikitude Target Collection). The .wtc file can be packed into the application bundle and a file URL retrieved using the `NSBundle` method `-URLForResource:withExtension:subdirectory:` or uploaded to a server and downloaded from the Wikitude Native SDK.  First, the `TargetCollectionResource` is created through the `createTargetCollectionResourceFromURL:completion` factory method from `WTWikitudeNativeSDK` and when it successfully finished loading the file containing the target collection, an `ImageTracker` can be created with it as a parameter.  To get notified when the image tracker finished loading, its delegate method `-imageTrackerDidLoadTargets:` is called or `-imageTracker:didFailToLoadTargets:` if the .wtc could not be loaded. If the target collection resource finished successfully, but the image tracker failed to load the targets, it means that the file was loaded successfully, but the image tracker was unable to use it, either because it is corrupted, or because it is from an unsupported version, or if the file is not a target collection at all. ```objc [self.wikitudeSDK start:nil completion:^(BOOL isRunning, NSError * __nonnull error) {     if ( !isRunning ) {         NSLog(@\&quot;Wikitude SDK is not running. Reason: %@\&quot;, [error localizedDescription]);     }     else     {         __weak typeof(self) weakSelf = self;                  NSURL *imageTrackerResourceURL = [[NSBundle mainBundle] URLForResource:@\&quot;magazine\&quot; withExtension:@\&quot;wtc\&quot; subdirectory:@\&quot;Assets\&quot;];         self.targetCollectionResource = [self.wikitudeSDK.trackerManager createTargetCollectionResourceFromURL:imageTrackerResourceURL completion:^(BOOL success, NSError * _Nullable error) {             if ( !success )             {                 NSLog(@\&quot;Failed to load URL resource. Reason: %@\&quot;, [error localizedDescription]);             }             else             {                 weakSelf.imageTracker = [weakSelf.wikitudeSDK.trackerManager createImageTrackerFromTargetCollectionResource:weakSelf.targetCollectionResource delegate:weakSelf configuration:nil];             }         }];     } }]; ```  Next we will have a closer look on how to get on tracker specific data. The `WTImageTrackerDelegate` provides three methods that will be called when the tracker found, lost or tracked targets.  * `-imageTracker:didRecognizeImage:` is called if a new target was found in the current camera frame * `-imageTracker:didTrackImage:` is called when an already known target moved to a new position * `-imageTracker:didLoseImage:` is called when an already known target could not be found anymore in the latest camera frame  The WTImageTarget object provides information about which target changed and what changed for the target, e.g. its position which would be represented through a OpenGL like model view matrix. ```objc - (void)imageTracker:(nonnull WTImageTracker *)imageTracker didRecognizeTarget:(nonnull WTImageTarget *)recognizedTarget {     NSLog(@\&quot;recognized target '%@'\&quot;, [recognizedTarget name]);     _isTracking = YES; }  - (void)imageTracker:(nonnull WTImageTracker *)imageTracker didTrackTarget:(nonnull WTImageTarget *)trackedTarget {     [self.renderableRectangle setProjectionMatrix:trackedTarget.projection];     [self.renderableRectangle setModelViewMatrix:trackedTarget.modelView]; }  - (void)imageTracker:(nonnull WTImageTracker *)imageTracker didLoseTarget:(nonnull WTImageTarget *)lostTarget {     NSLog(@\&quot;lost target '%@'\&quot;, [lostTarget name]);     _isTracking = NO; }   - (void)imageTrackerDidLoadTargets:(nonnull WTImageTracker *)imageTracker {     NSLog(@\&quot;Image tracker loaded\&quot;); }  - (void)imageTracker:(nonnull WTImageTracker *)imageTracker didFailToLoadTargets withError:(nonnull NSError *)error {     NSLog(@\&quot;Unable to load image tracker. Reason: %@\&quot;, [error localizedDescription]); } ```  &lt;a id=\&quot;ExtendedClientTrackingiOS\&quot;&gt;&lt;/a&gt; "
});

documentTitles["imagerecognitionnative.html#extended-2d-image-tracking-ios"] = "Extended 2D Image Tracking iOS";
index.add({
    url: "imagerecognitionnative.html#extended-2d-image-tracking-ios",
    title: "Extended 2D Image Tracking iOS",
    body: "### Extended 2D Image Tracking iOS  Based on the above to enable Extended Tracking for a tracker you need to provide a String array which defines which targets should be extended. In the sample we simply set a wildcard `*` so that all targets in this tracker are extended.  ```objc weakSelf.imageTracker = [weakSelf.wikitudeSDK.trackerManager createImageTrackerFromTargetCollectionResource:weakSelf.targetCollectionResource delegate:weakSelf configuration:^(WTImageTrackerConfiguration *imageTrackerConfiguration) {     imageTrackerConfiguration.extendedTargets = @[@\&quot;*\&quot;]; }]; ```  "
});



documentTitles["cloudrecognitionnative.html#cloud-recognition"] = "Cloud Recognition";
index.add({
    url: "cloudrecognitionnative.html#cloud-recognition",
    title: "Cloud Recognition",
    body: "## Cloud Recognition  This example shows how to recognize images on a cloud server and then overlay it with augmentations utilizing the `ImageTracker` and `CloudRecognitionService` classes.   For a better understanding, here are some terms that will be used in the following and other sections of this documentation related to vision-based augmented reality.  - **Target**: An image and its associated extracted data that is used to recognize an image.  - **Target Collection**: A group of `targets` that are searched together. Think of it as a directory, which contains all your images you want to search. The Wikitude SDK can work with two different sorts of `Target Collections` 	+ On-device Target Collection: a static `wtc` file containing the extracted data of your images. Can consist of up to 1,000 images. 	+ Cloud Target Collection: A target collection stored on the Wikitude server. See `Cloud Archive` below. Can consist of up to 50,000 images.  - **Cloud Archive**: An archive stored on the server that is optimized for cloud-based recognition. It is generated from a `Target Collection` and is used in combination with `CloudRecognitionService` .   - **CloudRecognitionService**: Instead of analysing and computing the live camera feed directly on the device, the `CloudRecognitionService` will send the image(s) taken by the camera to the Wikitude Cloud Recognition server. The server will then do the hard work of trying to match the image with your targets in the specified cloud archive. Beside the benefit of searching in large image database, using the `CloudRecognitionService` has also a positive impact on the general performance in most cases. Especially when using a large target collection and on older devices.     For both Cloud Recognition samples below we will use external rendering. If you don't know what that means please go through the section on [rendering](renderingnative.html) before starting here.  The `CloudRecognitionService` is able to run in two modes, called on-click and continuous. In On-Click mode a single recognition cycle will be executed, while in continuous mode the recognition will be run repeatedly with a variable interval.  Both view controllers are located in `Controller/CloudTracking`.  "
});

documentTitles["cloudrecognitionnative.html#regional-server-endpoints"] = "Regional server endpoints";
index.add({
    url: "cloudrecognitionnative.html#regional-server-endpoints",
    title: "Regional server endpoints",
    body: "#### Regional server endpoints Before we get started please note that you have to choose which regional-distributed Wikitude server the SDK should contact.  The cloud recognition server region can be selected by calling `-setCloudRecognitionServerRegion:` which is a method of `WTTrackerManager`. As a parameter, pass a value of `WTCloudRecognitionServerRegion` to specify the regional server. Every cloud recognition service that is created afterwards, will contact the specified server.   &lt;a id=\&quot;OnClickCloudTracking\&quot;&gt;&lt;/a&gt; "
});

documentTitles["cloudrecognitionnative.html#on-click-cloud-tracking"] = "On-Click Cloud Tracking";
index.add({
    url: "cloudrecognitionnative.html#on-click-cloud-tracking",
    title: "On-Click Cloud Tracking",
    body: "### On-Click Cloud Tracking  The starting point for on-click recognition is `WTOnClickCloudRecognition`. In `-viewDidLoad` we create a new instance of `WTWikitudeNativeSDK` and initialize it with a valid license key.   ```objc self.wikitudeSDK = [[WTWikitudeNativeSDK alloc] initWithRenderingMode:WTRenderingMode_External delegate:self]; [self.wikitudeSDK setLicenseKey:kWTLicenseKey];  ```  Then in `-viewDidAppear:` the Wikitude Native SDK is started using the `-start:completion:` method. If the SDK could be started, a object of type `WTCloudRecognitionService` is created using the `WTTrackerManager` factory method `-createCloudRecognitionServiceWithClientToken:targetCollectionId:completion`. The returned pointer needs to be retained in order to keep it alive, so assign it to a strong property. In the completion block we need to check if the cloud recognition service was successfully initialized, and if so, we can create an image tracker with it by using the `-createImageTrackerFromCloudRecognitionService:delegate:configuration` factory method.  ```objc [self.wikitudeSDK start:nil completion:^(BOOL isRunning, NSError * __nonnull error) {     if ( !isRunning ) {         NSLog(@\&quot;Wikitude SDK is not running. Reason: %@\&quot;, [error localizedDescription]);     }     else     {         __weak typeof(self) weakSelf = self;                  self.cloudRecognitionService = [self.wikitudeSDK.trackerManager createCloudRecognitionServiceWithClientToken:@\&quot;b277eeadc6183ab57a83b07682b3ceba\&quot; targetCollectionId:@\&quot;54e4b9fe6134bb74351b2aa3\&quot; completion:^(BOOL success, NSError * error) {             if ( !success )             {                 NSLog(@\&quot;Cloud recognition service failed to initialize with error: %@\&quot;, [error localizedDescription]);             }             else             {                 NSLog(@\&quot;Creating image tracker\&quot;);                 weakSelf.imageTracker = [weakSelf.wikitudeSDK.trackerManager createImageTrackerFromCloudRecognitionService:weakSelf.cloudRecognitionService delegate:weakSelf configuration:nil];             }         }];     } }]; ```  When an image tracker is initialized with a cloud recognition service, the `imageTrackerDidLoadTargets` and `imageTracker:didFailToLoadTargets` are not called during initialization, but rather after receiving a valid response from the server and they inform us whether the tracker was able to load and initialize the targets received it received from the server.  ```objc - (void)imageTrackerDidLoadTargets:(nonnull WTImageTracker *)imageTracker {     NSLog(@\&quot;Image tracker loaded\&quot;); }  - (void)imageTracker:(WTCloudTracker * __nonnull)imageTracker didFailToLoadTargets:(NSError * __nonnull)error {     NSLog(@\&quot;Image tracker failed to load with error: %@\&quot;, [error localizedDescription]); } ```  To start a single recognition, call the `-recognize:` method. The first parameter in the block is the response returned from the cloud recognition service. To call the `-recognize:errorHandler:` method, a `UIButton` is set up to call a specific method once it was touched.  ```objc - (IBAction)sendCloudRecognitionRequest:(id)sender {     if ( self.cloudRecognitionService &amp;&amp; self.cloudRecognitionService.initialized )     {         [self.cloudRecognitionService recognize:^(WTCloudRecognitionServiceResponse * _Nullable response, NSError * _Nullable error) {             if ( response )             {                 if ( response.recognized )                 {                     NSLog(@\&quot;Recognized target '%@' which has a rating of '%ld'\&quot;, [response.targetInformations objectForKey:WTCloudRecognitionServiceResponseKey_TargetName], (long)[[response.targetInformations objectForKey:WTCloudRecognitionServiceResponseKey_TargetRating] integerValue]);                     NSLog(@\&quot;Associated (custom) metadata: %@\&quot;, response.metadata);                 }                 else                 {                     NSLog(@\&quot;No target image found in the analysed camera frame.\nKeep Calm \n\t&amp;\nKeep Looking\&quot;);                 }             }             else             {                 NSLog(@\&quot;Cloud recognition recognition failed. Reason: %@\&quot;, [error localizedDescription]);             }         }];     } }  ``` Please note that only a recognize call is made if the cloud recognition service finished initializing. In case the server communication was successful, the first parameter in the block is a valid object of type `WTCloudRecognitionServiceResponse` that represents the server result. This object contains information if a image target was found or not, its name and, if specified, its associated meta data. In case of an error, the second parameter will contain a valid `NSError` object which contains detailed information about why the communication failed.  Since both simple image tracking and this use the `WTImageTrackerDelegate` protocol, all tracking related methods to draw a augmentation around the recognized target are available as well.   &lt;a id=\&quot;ContinuousClientTracking\&quot;&gt;&lt;/a&gt; "
});

documentTitles["cloudrecognitionnative.html#continuous-cloud-tracking"] = "Continuous Cloud Tracking";
index.add({
    url: "cloudrecognitionnative.html#continuous-cloud-tracking",
    title: "Continuous Cloud Tracking",
    body: "### Continuous Cloud Tracking  On-Click recognition is useful in some particular cases, but more often than not you probably want to use continuous recognition. For continuous cloud recognition we set an interval in which the `CloudRecognitionService` automatically calls the recognize function.  To start continuous recognition, simply call the `-startContinuousRecognitionWithInterval:interruptionHandler:responseHandler:` cloud recognition service method once it finished initializing.  ```objc if ( self.cloudRecognitionService &amp;&amp; self.cloudRecognitionService.initialized ) {     __weak typeof(self) weakSelf = self;     [self.cloudRecognitionService startContinuousRecognitionWithInterval:1.5 interruptionHandler:nil responseHandler:^(WTCloudRecognitionServiceResponse *response, NSError * error) {         if (response)         {             NSLog(@\&quot;received continuous response...\&quot;);             if ( response.recognized ) {                 NSLog(@\&quot;target recognized...\&quot;);                 dispatch_async(dispatch_get_main_queue(), ^{                     [weakSelf.cloudRecognitionService stopContinuousRecognition];                     [weakSelf.continuousRecognitionButton setTitle:@\&quot;Start Continuous Recognition\&quot; forState:UIControlStateNormal];                 });             }             else             {                 NSLog(@\&quot;target NOT recognized...\&quot;);             }         }         else         {             NSLog(@\&quot;Cloud Recognition Service error %ld occurred. %@\&quot;, (long)error.code, [error localizedDescription]);         }     }];     [self.continuousRecognitionButton setTitle:@\&quot;Stop Continuous Recognition\&quot; forState:UIControlStateNormal]; } else {     NSLog(@\&quot;Cloud Recognition Service is not ready yet.\&quot;); } ``` As before, this method is called once a `UIButton` was touched.  The first parameter defines in which interval new camera frames should be sent to the server for processing. The second parameter is again a response handler with information about the recognized target and behaves the same way as in the case of On-Click recognition.  To stop a continuous recognition session, e.g. once a target was found, simply call the `-stopContinuousRecognition` method.  "
});



documentTitles["instanttrackingnative.html#instant-tracking"] = "Instant Tracking";
index.add({
    url: "instanttrackingnative.html#instant-tracking",
    title: "Instant Tracking",
    body: "## Instant Tracking  The following sections detail the instant tracking feature of the Wikitude Native SDK by introducing a minimal implementation, showcasing the simplicity the Wikitude Native SDK provides.  The example is preceded by an introductory section that introduces the instant tracking algorithm with brevity.  1. [Introduction](#introduction) 2. [Basic Instant Tracking](#basicinstanttracking)  &lt;a id=\&quot;introduction\&quot;&gt;&lt;/a&gt; "
});

documentTitles["instanttrackingnative.html#introduction-12"] = "Introduction (1/2)";
index.add({
    url: "instanttrackingnative.html#introduction-12",
    title: "Introduction (1/2)",
    body: "### Introduction (1/2)  Instant tracking is an algorithm that, contrary to those previously introduced in the Wikitude SDK, does not aim to recognize a predefined target and start the tracking procedure thereafter, but immediately start tracking in an arbitrary environment. This enables very specific use cases to be implemented.  The algorithm works in two distinct states; the first of which is the initialization state. In this state the user is required to define the origin of the tracking procedure by simply pointing the device and thereby aligning an indicator. Once the alignment is found to be satisfactory by the user (which the users needs to actively confirm), a transition to the tracking state is performed. In this state, the environment is being tracked, which allows for augmentations to be placed within the scene.   ![Initialization State and Tracking State](images/instant_tracking_iosnative.png \&quot;Initialization State and Tracking State\&quot;)   The instant tracking algorithm requires another input value to be provided in the initialization state. Specifically, the height of the tracking device is required in order to accurately adjust the scale of augmentations within the scene. To this end, the example features a range input element that allows the height to be set in meters.  &lt;a id=\&quot;basicinstanttracking\&quot;&gt;&lt;/a&gt; "
});

documentTitles["instanttrackingnative.html#basic-instant-tracking-22"] = "Basic Instant Tracking (2/2)";
index.add({
    url: "instanttrackingnative.html#basic-instant-tracking-22",
    title: "Basic Instant Tracking (2/2)",
    body: "### Basic Instant Tracking (2/2)   The *Instant Tracking* example provides a minimal implementation of the instant tracking algorithm. First we have to make some additions to our `UIViewController`. In order to use instant tracking, the `UIViewController` has to conform to the `WTInstantTrackerDelegate` protocol and we will need a `WTInstantTracker` and a `WTInstantTrackingState` as members.  ```objc @interface WTInstantTrackerViewController () &lt;WTWikitudeNativeSDKDelegate, WTInstantTrackerDelegate&gt; ```  ```objc @property (nonatomic, strong) WTInstantTracker                      *instantTracker;  @property (nonatomic, assign) WTInstantTrackingState                trackingState; ```  Initialize both the `WTInstantTracker` and the `WTInstantTrackingState ` after checking if the `WTWikitudeNativeSDK` is running in `viewDidAppear:`.  ```objc self.instantTracker = [self.wikitudeSDK.trackerManager createInstantTracker:self configuration:nil]; self.trackingState = WTInstantTrackerInitializing; ```  A `WTInstantTracker` can, minimally, be instantiated with just the previously generated tracker instance, although supplying drawables to be rendered in both the initialization state and the tracking state is advisable for any practical use case. Therefore a `StrokedRectangle` instance is generated and supplied as well.  ```objc self.renderableRectangle = [[StrokedRectangle alloc] init]; self.renderableRectangle.scale = 0.45; ```  To use our `StrokedRectangle` for the initialization of `WTInstantTracker`, we implement the `instantTracker:didChangeInitializationPose:` callback function of the `WTInstantTrackerDelegate`.  ```objc - (void)instantTracker:(nonnull WTInstantTracker *)instantTracker didChangeInitializationPose:(nonnull WTInitializationPose *)pose {     [self.renderableRectangle setProjectionMatrix:pose.projection];     [self.renderableRectangle setModelViewMatrix:pose.modelView]; } ``` This callback function supplies a `WTInstantTracker` and the current `WTInitializationPose`, the latter of which can be used to set the projection matrix and model view matrix of the `StrokedRectangle` so it is displayed properly during the initialization state.  Next we need a means to transition from one state to the other. For this task we provide the `toggleInstantTrackingState:` function which we conveniently call on a button click. `self.trackingState` holds the value of the current state.  ```objc - (IBAction)toggleInstantTrackingState:(id)sender {     if ( [[self.instantTrackingButton currentTitle] isEqualToString:@\&quot;Start Tracking\&quot;] )     {         if ( WTInstantTrackerInitializing == self.trackingState )         {             [self.instantTrackingButton setTitle:@\&quot;Start Initialization\&quot; forState:UIControlStateNormal];             [self.instantTracker setActiveInstantTrackingState:WTInstantTrackerTracking];         }     }     else     {         if ( WTInstantTrackerTracking == self.trackingState )         {             [self.instantTrackingButton setTitle:@\&quot;Start Tracking\&quot; forState:UIControlStateNormal];             [self.instantTracker setActiveInstantTrackingState:WTInstantTrackerInitializing];         }     } } ```  We now draw an orange rectangle while the instant tracker is initializing, but we want the rectangle to be blue once we're in the tracking state.  ```objc - (void)instantTracker:(nonnull WTInstantTracker *)instantTracker didChangeState:(WTInstantTrackingState)newState {     _trackingState = newState;          if (_trackingState == WTInstantTrackerInitializing) {         [self.renderableRectangle setColor:[UIColor colorWithRed:1.00f green:0.58f blue:0.16f alpha:1.0f]];     } else {         [self.renderableRectangle setColor:[UIColor colorWithRed:0.41f green:0.60f blue:0.76f alpha:1.0f]];     } } ```  In the `WTInstantTracker`'s callback function `instantTracker:didChangeState:` we control the color of the `StrokedRectangle` for a better visual representation. However this only changes the color of the rectangle and not its position, which is why we need the `instantTracker:didTrack:` callback function to update the projection matrix and the model view matrix of the rectangle.  ```objc - (void)instantTracker:(nonnull WTInstantTracker *)instantTracker didTrack:(nonnull WTInstantTarget *)target {     [self.renderableRectangle setProjectionMatrix:target.projection];     [self.renderableRectangle setModelViewMatrix:target.modelView]; } ```  Next, we provide the `updateDeviceHeightAboveGround:` function to set the `deviceHeight` property of the `WTInstantTracker` and connect it to a `UISlider`. While this change is, strictly speaking, not required, we strongly recommend every application to supply the device height accurately by this method or another for the Wikitude SDK to provide an accurate scale.  ```objc - (IBAction)updateDeviceHeightAboveGround:(UISlider *)sender {     [self.instantTracker setDeviceHeightAboveGround:@(sender.value)]; } ```  Lastly we have to make the height slider invisible when the state changes from initialization to tracking, so set its alpha value correctly in `instantTracker:didChangeState:`.  ```objc dispatch_async(dispatch_get_main_queue(), ^{     if ( WTInstantTrackerTracking == newState )     {         self.deviceHeightAboveGroundSlider.alpha = 0.0;     }     else     {         self.deviceHeightAboveGroundSlider.alpha = 1.0;     } }); ```  The example outlined in this section renders an orange rectangle augmentation when in initialization state as its indicator and a corresponding blue rectangle augmentation when in tracking state. While the example is quite trivial, we believe it serves the purpose of familiarizing the reader with the core concepts of instant tracking well.   ![Initialization State and Tracking State](images/instant_tracking_iosnative.png \&quot;Initialization State and Tracking State\&quot;)    "
});



documentTitles["renderingnative.html#rendering"] = "Rendering";
index.add({
    url: "renderingnative.html#rendering",
    title: "Rendering",
    body: "## Rendering  This example shows and explain how rendering works in combination with the Wikitude SDK Native API. There are two methods of rendering available in the Wikitude Native SDK. We call them internal and external rendering. Internal means the OpenGL view is setup by the Wikitude SDK and the SDK user can define custom rendering, that is executed by the Wikitude SDK. On the other hand external rendering means the SDK user sets up the OpenGL view and integrates the Wikitude SDK into this rendering setup.      1. [Rendering APIs](#rendering_apis) 2. [External Rendering](#externalrendering) 3. [Internal Rendering](#internalrendering)  &lt;a id=\&quot;rendering_apis\&quot;&gt;&lt;/a&gt; "
});

documentTitles["renderingnative.html#rendering-apis"] = "Rendering APIs";
index.add({
    url: "renderingnative.html#rendering-apis",
    title: "Rendering APIs",
    body: "### Rendering APIs The Wikitude Native SDK for iOS currently supports the following [RenderingAPIs](iosnativeapi://Classes/WTNativeSDKStartupConfiguration.html#//api/name/targetRenderingAPI):  * OpenGL ES 3 * OpenGL ES 2  How the Rendering API can be selected can be seen at [Rendering API selection for External Rendering](#external_rendering_api) or [Rendering API selection for Internal Rendering](#internal_rendering_api).  &lt;a id=\&quot;externalrendering\&quot;&gt;&lt;/a&gt; "
});

documentTitles["renderingnative.html#external-rendering"] = "External Rendering";
index.add({
    url: "renderingnative.html#external-rendering",
    title: "External Rendering",
    body: "### External Rendering Most of the examples in the Wikitude Native SDK example application use external rendering, simply because it might be the preferred usage by developers. The example application comes with a simple OpenGL ES view (`ExternalEAGLView`) and an also very simple renderer (`ExternalRenderer`).  To activate external rendering you need to pass `WTRenderingMode_External` to the `WTWikitudeNativeSDK` method `-initWithRenderingMode:delegate`.  ```objc self.wikitudeSDK = [[WTWikitudeNativeSDK alloc] initWithRenderingMode:WTRenderingMode_External delegate:self]; ```   During the Wikitude Native SDK startup phase, which is initialized with a call to `-start:completion:`, several methods from the `WTWikitudeNativeSDKDelegate` protocol are called. They are needed to prepare the Wikitude Native SDK for external rendering. All methods in the `WTWikitudeNativeSDKDelegate` protocol are marked as optional, but the Wikitude Native SDK will call its `-wikitudeNativeSDK:didEncounterInternalError:` delegate method if a required method is not implemented or returned an invalid value. The required methods are:  * -wikitudeNativeSDK:didCreatedExternalUpdateHandler: * -wikitudeNativeSDK:didCreatedExternalDrawHandler: * -eaglViewSizeForExternalRenderingInWikitudeNativeSDK: * -eaglContextForVideoCameraInWikitudeNativeSDK:     ```objc  - (void)wikitudeNativeSDK:(WTWikitudeNativeSDK * __nonnull)wikitudeNativeSDK didCreatedExternalUpdateHandler:(WTWikitudeUpdateHandler __nonnull)updateHandler {     self.wikitudeUpdateHandler = updateHandler; }  - (void)wikitudeNativeSDK:(WTWikitudeNativeSDK * __nonnull)wikitudeNativeSDK didCreatedExternalDrawHandler:(WTWikitudeDrawHandler __nonnull)drawHandler {     self.wikitudeDrawHandler = drawHandler; }  - (CGRect)eaglViewSizeForExternalRenderingInWikitudeNativeSDK:(WTWikitudeNativeSDK * __nonnull)wikitudeNativeSDK {     return self.eaglView.bounds; }  - (EAGLContext *)eaglContextForVideoCameraInWikitudeNativeSDK:(WTWikitudeNativeSDK * __nonnull)wikitudeNativeSDK {     if (!_sharedWikitudeEAGLCameraContext )     {         EAGLContext *rendererContext = [self.renderer internalContext];         self.sharedWikitudeEAGLCameraContext = [[EAGLContext alloc] initWithAPI:[rendererContext API] sharegroup:[rendererContext sharegroup]];     }     return self.sharedWikitudeEAGLCameraContext; }  ```  The first two methods provide block objects, that need to be called every frame from the external rendering system. There purpose is to update internal SDK logic and draw the camera stream in OpenGL. The last one is used to get to know the current OpenGL view size in order to draw the camera frame fullscreen and with the correct aspect ratio. External rendering also requires a shared `EAGLContext` object that is used by the Wikitude Native SDK to issue camera related OpenGL ES calls. This way custom rendering and Wikitude rendering do not influence each other and less conflicts can occur.  An example of how those block objects can be used is the following:  ```objc if ( self.wikitudeUpdateHandler     &amp;&amp;      self.wikitudeDrawHandler ) {     self.wikitudeUpdateHandler();     self.wikitudeDrawHandler(); } // ...external rendering code... ``` Such a snippet is typically found somewhere in the external render loop.  &lt;a id=\&quot;external_rendering_api\&quot;&gt;&lt;/a&gt; "
});

documentTitles["renderingnative.html#rendering-api-selection-for-external-rendering"] = "Rendering API selection for External Rendering";
index.add({
    url: "renderingnative.html#rendering-api-selection-for-external-rendering",
    title: "Rendering API selection for External Rendering",
    body: "#### Rendering API selection for External Rendering For external rendering the SDK needs to know which Rendering API was used by the external rendering system so the correct rendering API calls can be made internally. If this is not explicitly set, the SDK will expect an OpengL ES 2 context.  To set the rendering API, use the `WTNativeSDKStartupConfiguration` method [`-targetRenderingAPI:`](iosnativeapi://Classes/WTNativeSDKStartupConfiguration.html#//api/name/targetRenderingAPI)  Make sure that only one rendering API is set, otherwise the SDK does not start and reports an error in the completion handler of [`-start:completion`](iosnativeapi://Classes/WTWikitudeNativeSDK.html#//api/name/start:completion:)  An example implementation of this can be found in the external rendering example of the Wikitude SDK (Native API) example application. Here the rendering API is specified with an converted value from the external rendering system.  ```objc WTRenderingAPI renderingAPI = [WTExternalRenderingViewController convertToWikitudeRenderingAPI:self.renderer.activeRenderingAPI]; startupConfiguration.targetRenderingAPI = [NSOrderedSet orderedSetWithObjects:renderingAPI, nil]; ```   &lt;a id=\&quot;internalrendering\&quot;&gt;&lt;/a&gt; "
});

documentTitles["renderingnative.html#internal-rendering"] = "Internal Rendering";
index.add({
    url: "renderingnative.html#internal-rendering",
    title: "Internal Rendering",
    body: "### Internal Rendering In case no OpenGL ES 2 rendering is already setup in the hosting Wikitude Native SDK application, the Wikitude Native SDK brings its own set of OpenGL ES 2 compatible classes to do so. These classes are `WTEAGLView` and `WTRenderer`. Objects of those classes can be retrieved through `WTWikitudeNativeSDK` methods. To start the Wikitude Native SDK with internal rendering, pass `WTRenderingMode_Internal` to the `-initWithRenderingMode:delegate:` method.  ```objc self.wikitudeSDK = [[WTWikitudeNativeSDK alloc] initWithRenderingMode:WTRenderingMode_Internal delegate:self];  self.wikitudeRenderer = [self.wikitudeSDK createRenderer]; self.wikitudeEAGLView = [self.wikitudeSDK createEAGLView];  ```  After all required objects are created, view and renderer have to be connected through a call to `setRenderer:`.  ```objc [self.wikitudeEAGLView setRenderer:self.wikitudeRenderer]; ``` After those two objects are connected, the view has to be added to the view hierarchy of your application. This can either be done using Storyboards or programmatically. The Wikitude Native SDK example application does it in code.  ```objc [self.view addSubview:self.wikitudeEAGLView]; [self.wikitudeEAGLView setTranslatesAutoresizingMaskIntoConstraints:NO];  NSDictionary *views = NSDictionaryOfVariableBindings(_wikitudeEAGLView); [self.view addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@\&quot;|[_wikitudeEAGLView]|\&quot; options:0 metrics:nil views:views]]; [self.view addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@\&quot;V:|[_wikitudeEAGLView]|\&quot; options:0 metrics:nil views:views]]; ```  To do some custom OpenGL ES 2 calls from outside the Wikitude Native SDK, custom update and draw block objects can be passed to the Wikitude Native SDK. The corresponding delegate methods are called during the startup phase.  ```objc - (WTCustomUpdateHandler)wikitudeNativeSDKNeedsExternalUpdateHandler:(WTWikitudeNativeSDK * __nonnull)wikitudeNativeSDK {     /* Intentionally returning a nil handler here */     return ^(){}; }  - (WTCustomDrawHandler)wikitudeNativeSDKNeedsExternalDrawHandler:(WTWikitudeNativeSDK * __nonnull)wikitudeNativeSDK {     return ^(){         if ( _isTracking ) {             [self.renderableRectangle drawInContext:[EAGLContext currentContext]];         }     }; } ``` In this snippet only custom rendering is done and no update logic.   &lt;a id=\&quot;internal_rendering_api\&quot;&gt;&lt;/a&gt; "
});

documentTitles["renderingnative.html#rendering-api-selection-for-internal-rendering"] = "Rendering API selection for Internal Rendering";
index.add({
    url: "renderingnative.html#rendering-api-selection-for-internal-rendering",
    title: "Rendering API selection for Internal Rendering",
    body: "#### Rendering API selection for Internal Rendering For internal rendering the SDK needs to know which rendering API context is shall create. If this is not explicitly set the SDK will create and use an Open GL ES 2 context.  To set the rendering API use `WTNativeSDKStartupConfiguration`'s method [`-targetRenderingAPI:`](iosnativeapi://Classes/WTNativeSDKStartupConfiguration.html#//api/name/targetRenderingAPI).  The SDK will try to create the given rendering APIs in the following order: OpenGL ES 3 &gt; OpenGL ES 2.   A `WTNativeSDKStartupConfiguration` object is available in the first block of `-start:completion` and can be modified like shown below:  ```objc /* Try to create an OpenGL ES 3 context. If OpenGL ES 3 is not supported on the current device, an OpenGL ES 2 context is created */  startupConfiguration.targetRenderingAPI = [NSOrderedSet orderedSetWithObjects:WTRenderingAPI_OpenGL_ES_3, WTRenderingAPI_OpenGL_ES_2, nil]; ```  ```objc /* Try to create an OpenGL ES 3 context. If the current devcie does not support OpenGL ES 3, the SDK will not start and report an error in the completion handler of `-start:completion:` */  startupConfiguration.targetRenderingAPI = [NSOrderedSet orderedSetWithObjects:WTRenderingAPI_OpenGL_ES_3, nil]; ```  To check which rendering API context was created in case multiple desired rendering APIs were given, implement the `WTWikitudeNativeSDKDelegate` method [`-wikitudeNativeSDK:didSetupRendererWithAPI:`](iosnativeapi://Protocols/WTWikitudeNativeSDKDelegate.html#//api/name/wikitudeNativeSDK:didSetupRendererWithAPI:) to know what the SDK did setup internally.  ```objc - (void)wikitudeNativeSDK:(WTWikitudeNativeSDK *)wikitudeNativeSDK didSetupRendererWithAPI:(WTRenderingAPI)renderingAPI {     NSLog(@\&quot;Wikitude SDK did setup rendering with API '%@'\&quot;, renderingAPI); } ```   "
});



documentTitles["pluginsapi.html#plugins-api"] = "Plugins API";
index.add({
    url: "pluginsapi.html#plugins-api",
    title: "Plugins API",
    body: "## Plugins API  This guide consists of multiple sections, first we discuss Wikitude SDK Plugins in general, than we talk about platform specifics and how to register a plugin with the Wikitude SDK and then we go through each of the sample plugins included with the Wikitude Example Applications.  1. [About Wikitude SDK Plugins](#about) 2. [Platform Specifics](#platformspecifics) 3. [Registering Plugins](#registerplugin) 4. [QR &amp; Barcode Plugin](#barcode) 5. [Face Detection Plugin](#facedetection)  &lt;a id=\&quot;about\&quot;&gt;&lt;/a&gt; "
});

documentTitles["pluginsapi.html#about-wikitude-sdk-plugins"] = "About Wikitude SDK Plugins";
index.add({
    url: "pluginsapi.html#about-wikitude-sdk-plugins",
    title: "About Wikitude SDK Plugins",
    body: "### About Wikitude SDK Plugins  Technically a plugin is a class, either written in C++ or Java, that is derived from the Wikitude Plugin base class. Beside lifecycle handling and options to enable and disable the plugin, the Plugin class has four main methods that you can override `cameraFrameAvailable` which is called each time the camera has a new frame, `update` which is called after each image recognition cycle as well as `startRender` and `endRender` which are called before and after the Wikitude SDK does its rendering.  The most important thing to remember when working with plugins is that they need to have a unique identifier! If the attempt is made to register a plugin with an identifier that is already known to the Wikitude SDK, the register method call will return false.  "
});

documentTitles["pluginsapi.html#plugin-base-class"] = "Plugin Base Class";
index.add({
    url: "pluginsapi.html#plugin-base-class",
    title: "Plugin Base Class",
    body: "### Plugin Base Class ``` class Plugin {    public:       Plugin(std::string identifier_);       ~Plugin();       string getIdentifier() const; // returns a unique plugin identifier       bool processesColorCameraFrames(); // returns true if the plugins wants to process color frames instead of bw         void setEnabled(bool enabled_);       bool isEnabled();         string callJavaScript(string javaScriptSnippet); // evaluates the given JavaScript snippet in the currently loaded ARchitect World context.      protected:       void initialize(); // called when the plugin is initially added to the Wikitude SDK       void pause(); // called when the Wikitude SDK is paused e.g. the application state changes from active to background       void resume(uint pausedTime_); // called when the Wikitude SDK resumes e.g. from background to active state. pausedTime represents the time in milliseconds that the plugin was not updated.       void destroy(); // called when the plugin is removed from the Wikitude SDK         void cameraFrameAvailable(const Frame&amp;; cameraFrame_); // called each time the camera has a new frame       void update(const vector&lt;RecognizedTarget&gt; recognizedTargets_); // called each time the Wikitude SDK renders a new frame        void startRender(); // called before any Wikitude SDK internal rendering is done       void endRender(); // called right after any Wikitude SDK internal rendering is done     protected:       string      _identifier;       bool        _enabled; };   ```  With those methods in place your plugin will be able to read the full camera image for your own purpose, where the YUV image is also processed in wikitude’s computer vision engine.  "
});

documentTitles["pluginsapi.html#information-about-recognized-targets"] = "Information about Recognized Targets";
index.add({
    url: "pluginsapi.html#information-about-recognized-targets",
    title: "Information about Recognized Targets",
    body: "### Information about Recognized Targets  In case you have the wikitude SDK running with ongoing image recognition, the plugin API will populate the `RecognizedTarget` in the `update` method once an image has been recognized. The plugin can then work with class `RecognizedTarget`, which wraps the details of the target image in the camera view. With that you can read out the pose of the target image and use it for your purposes. Additionally the call contains the calculated distance to the recognized target  ``` class RecognizedTarget {    public:       const string&amp;    getIdentifier() const; // the identifier of the target. The identifier is defined when the target is added to a target collection       const Mat4&amp;      getModelViewMatrix() const; // the model view matrix that defines the transformation of the target in the camera frame (translation, rotation, scale)       const Mat4&amp;      getProjectionMatrix() const;       const float      getDistanceToCamera() const; // represents the distance from the target to the camera in millimeter };  ```     &lt;a id=\&quot;platformspecifics\&quot;&gt;&lt;/a&gt; "
});

documentTitles["pluginsapi.html#platform-specifics"] = "Platform Specifics";
index.add({
    url: "pluginsapi.html#platform-specifics",
    title: "Platform Specifics",
    body: "### Platform Specifics        Thanks to Objective-C++, C++ plugins can be loaded very easily on iOS. Simply create a new C++ file, include and derive from `wikitude::sdk::Plugin` and create a `std::shared_ptr` from your plugin class. The created shared pointer can then be supplied to the Wikitude SDK specific plugin registration/removal API.  To mark a Objective-C file as Objective-C++, change its file extension from .m to .mm or change the type manually to Objective-C++ using Xcodes Identity and Type inspector.    &lt;a id=\&quot;registerplugin\&quot;&gt;&lt;/a&gt; "
});

documentTitles["pluginsapi.html#registering-plugins"] = "Registering Plugins";
index.add({
    url: "pluginsapi.html#registering-plugins",
    title: "Registering Plugins",
    body: "### Registering Plugins         The Wikitude Native SDK for iOS offers three methods to register/remove C++ plugins. All of them are accessible through the `WTWikitudeNativeSDK` class.  "
});

documentTitles["pluginsapi.html#registering-a-c-plugin"] = "Registering a C++ Plugin";
index.add({
    url: "pluginsapi.html#registering-a-c-plugin",
    title: "Registering a C++ Plugin",
    body: "#### Registering a C++ Plugin To register a C++ plugin, call the `-registerPlugin:` method and pass a `std::shared_ptr` wrapping your C++ plugin pointer. The following snippet shows how to define a property for a shared pointer, its initialization and the registration call.   ```objc @property (nonatomic, assign) std::shared_ptr&lt;BarcodePlugin&gt; barcodePlugin; // ... _barcodePlugin = std::make_shared&lt;BarcodePlugin&gt;(640, 480, self); // arguments are passed to the C++ class constructor // ... [self.wikitudeSDK registerPlugin:_barcodePlugin]; ```  "
});

documentTitles["pluginsapi.html#removing-a-c-plugin"] = "Removing a C++ Plugin";
index.add({
    url: "pluginsapi.html#removing-a-c-plugin",
    title: "Removing a C++ Plugin",
    body: "#### Removing a C++ Plugin To remove a already known C++ plugin, call either the `-removePlugin:` or `-removeNamedPlugin:` method. The first one takes a shared pointer as argument and tries to find a plugin that matches this plugins identifier. The second one tries to remove a C++ plugin based on a string parameter. The second one is interesting because it allows you to not have a property that holds the shared pointer, but to directly call `std::make_shared` when calling `-registerPlugin:`. If this is done, the hosting application has no reference to the plugin pointer anymore, but can still remove it using its unique identifier (which has to be known by the hosting application/developer).  ```objc [self.architectView removePlugin:_faceDetectionPlugin]; //... [self.architectView removeNamedPlugin:@\&quot;com.wikitude.plugin.face_detection\&quot;]; ```     &lt;a id=\&quot;barcode\&quot;&gt;&lt;/a&gt; "
});

documentTitles["pluginsapi.html#barcode-and-qr-code-reader"] = "Barcode and QR code reader";
index.add({
    url: "pluginsapi.html#barcode-and-qr-code-reader",
    title: "Barcode and QR code reader",
    body: "### Barcode and QR code reader  This samples shows a full implementation of the popular barcode library ZBar into the Wikitude SDK. As ZBar is licensed under LGPL2.1 this sample can also be used for other projects.  ZBar is an open source software suite for reading bar codes from various sources, such as video streams, image files and raw intensity sensors. It supports many popular symbologies (types of bar codes) including EAN-13/UPC-A, UPC-E, EAN-8, Code 128, Code 39, Interleaved 2 of 5 and QR Code.          The C++ barcode plugin is created when `WTBarcodePluginViewController` loads its view object. ```objc - (void)viewDidLoad {     [super viewDidLoad];      	//...         self.wikitudeSDK = [[WTWikitudeNativeSDK alloc] initWithRenderingMode:WTRenderingMode_External delegate:self]; 	//...          _barcodePlugin = std::make_shared&lt;BarcodePlugin&gt;(640, 480, self); }  ```  When `WTBarcodePluginViewController` starts the Wikitude Native SDK using the `-start:completion:` method, the C++ barcode plugin is registered using the `-registerPlugin:` method in the completion block.  ```objc - (void)viewDidAppear:(BOOL)animated {     [super viewDidAppear:animated];       	//...  	        [self.wikitudeSDK start:^(WTStartupConfiguration *startupConfiguration) {     //...     } completion:^(BOOL isRunning, NSError * __nonnull error) {         if ( !isRunning ) { 			//...         }         else         {             //...             [self.wikitudeSDK registerPlugin:_barcodePlugin];         }     }]; } ``` Please note that the plugin is only registered when the Wikitude Native SDK could actually start.  Now let's move to the plugins C++ code. First we'll have a look at the `BarcodePlugin.h` file. To create the bar code plugin we derive our `BarcodePlugin` class from `wikitude::sdk::Plugin` and override `initialize`, `destroy`, `cameraFrameAvailable` and `update`. We also declare the following member variables: `_worldNeedsUpdate`, `_image`, `_imageScanner` and `_presentingViewController`. The `_worldNeedsUpdate` variable will later be used as an indicator if we need to display the recognized barcode, `_image` and `_imageScanner` are classes from `zBar` which we'll use to scan for bar codes and `_presentingViewController` will hold a pointer to the `WTBarcodePluginViewController` from which we call a method every time we recognize a new barcode or QR code.   ```c++ #include &lt;zbar.h&gt;  #import &lt;WikitudeNativeSDK/Plugin.h&gt; #import &lt;WikitudeNativeSDK/Frame.h&gt; #import &lt;WikitudeNativeSDK/RecognizedTarget.h&gt;   @class WTBarcodePluginViewController;  class BarcodePlugin : public wikitude::sdk::Plugin { public:     BarcodePlugin(int cameraFrameWidth, int cameraFrameHeight, WTBarcodePluginViewController *presentingViewController);     virtual ~BarcodePlugin();      virtual void initialize();     virtual void destroy();      virtual void cameraFrameAvailable(const wikitude::sdk::Frame&amp; cameraFrame_);     virtual void update(const std::list&lt;wikitude::sdk::RecognizedTarget&gt;&amp; recognizedTargets_);  protected:     int                             _worldNeedsUpdate;          zbar::Image                     _image;     zbar::ImageScanner              _imageScanner;          WTBarcodePluginViewController   *_presentingViewController; }; ```  In the constructor we set `_worldNeedsUpdate` to zero indicating that there is no update necessary and initialize the `zBar::Image` member variable passing its constructor the width and height of the camera frame, the image format of `Y800`, set its data pointer to null and the data length to zero.  In the `initialize` method we configure the `zbar::ImageScanner` by calling `setConfig`, enabling all supported bar codes. If you are only interested in one or some particular types of codes, first disabling all bar code types and manually enabling each particular type would be the better idea. That way performance could be greatly improved.  ```c++ void BarcodePlugin::initialize() {         _imageScanner.set_config(zbar::ZBAR_NONE, zbar::ZBAR_CFG_ENABLE, 1); } ``` We react to the `destroy` event by setting the current data pointer of the `zbar::Image` member to null and length to zero.  ```c++ void BarcodePlugin::destroy() {     _image.set_data(nullptr, 0); } ```  The last but most interesting methods are `cameraFrameAvailable` and `update`. In the `cameraFrameAvailable` method we set the data of our previously initialized `zbar::Image` member variable to the frame data we just received and the length of the data to frame width * frame height by calling `set_data`. We then start the scanning process by calling the `scan` method of our `zBar::ImageScanner` passing the `zBar::Image` member instance. The `zBar::ImageScanner::scan` method returns the number of detected bar codes in the image frame, we save this number in a local variable `n`. If `n` is not equal to the result of the last frame, which we saved to `_worldNeedsUpdate` member variable, we know there was a new bar code detected (meaning there was no bar code in the last frame) or that there was a bar code in the last frame and now there isn't. When that's the case, we do another check if there really was a bar code detected this frame and if there was, we call the `presentBarcodeResult` method, passing the code content. ```c++ void BarcodePlugin::cameraFrameAvailable(const wikitude::sdk::Frame&amp; cameraFrame_) {     int frameWidth = cameraFrame_.getSize().width;     int frameHeight = cameraFrame_.getSize().height;          _image.set_data(cameraFrame_.getLuminanceData(), frameWidth * frameHeight);          int n = _imageScanner.scan(_image);          if ( n != _worldNeedsUpdate ) {         if ( n ) {             zbar::Image::SymbolIterator symbol = _image.symbol_begin();                          [_presentingViewController presentBarCodeResult:[NSString stringWithUTF8String:std::string(symbol-&gt;get_data()).c_str()]];         }     }          _worldNeedsUpdate = n; } ```  Back in the Objective-C class `WTBarcodePluginViewController`, the `-presentBarCodeResult:` method is implemented like the following:  ```c++ - (void)presentBarCodeResult:(NSString *)barcodeScanResult {     if ( barcodeScanResult ) {         dispatch_async(dispatch_get_main_queue(), ^{             [self.barcodeLabel setText:barcodeScanResult];         });     } } ``` Please note that the `-presentBarcodeResult:` method is not called from the main thread, meaning that we need to schedule any UI related calls on the main thread. This is done by executing a block asynchronously on the dispatch main queue.   To visualize the detected bar code, we use a NSLabel and set its text property to the detected bar code string.  &lt;a id=\&quot;facedetection\&quot;&gt;&lt;/a&gt; "
});

documentTitles["pluginsapi.html#face-detection"] = "Face Detection";
index.add({
    url: "pluginsapi.html#face-detection",
    title: "Face Detection",
    body: "### Face Detection  This samples shows how to add face detection to your Wikitude augmented reality experience using OpenCV.          The Face detection plugin example consists of the C++ classes `FaceDetectionPlugin`, `FaceDetectionPluginConnector` and the Objective-C class `WTFaceDetectionPluginViewController`. We will use OpenCV to detect faces in the current camera frame and OpenGL to render a rectangle around detected faces. `FaceDetectionPluginConnector` is used to connect the `FaceDetectionPlugin` class with the `WTFaceDetectionPluginViewController`. Since this class mainly exists to ease the implementation of a cross platform plugin, we will not go into any implementation details for this class. We also don't go into any OpenCV or OpenGL details. If one is interested in such topics, the source code is part of the Wikitude Native SDK example application.  `WTFaceDetectionPluginViewController` handles the face detection plugin creation and registration exactly as described in the previously bar code example. New for this example is a class method that converts UIDeviceOrientations into an int that is used by the face detection plugin to rotate the camera frame in order to always have faces in the right orientation. This class method is then used every time the device changes its orientation.  ```objc __weak typeof(self) weakSelf = self; [[NSNotificationCenter defaultCenter] addObserverForName:UIDeviceOrientationDidChangeNotification object:[UIDevice currentDevice] queue:[NSOperationQueue mainQueue] usingBlock:^(NSNotification *note) {                  weakSelf.faceDetectionPlugin-&gt;setFlipFlag( [WTFaceDetectionPluginViewController flipFlagForDeviceOrientation:[[UIDevice currentDevice] orientation]] ); }]; ```  Next we have a look at the `FaceDetectionPlugin` class. Again we we will leave out implementation details and focus on how we use the plugin itself. In the `cameraFrameAvailable` method we use OpenCV to detect faces in the current camera frame which the Wikitude SDK passes to the plugin. We call the observer which is an instance of the `FaceDetectionPluginConnector` to notify the view controller about the result. The plugin base class defines `startRender` and `endRender`, depending on, if you would like to render on top of or below of all rendering the Wikitude SDK does, you choose one of them, or both to override. To render below all Wikitude rendering we choose `startRender` and again call the `FaceDetectionPluginConnector` instance which in turn calls the view controller. Since we do not react on the result of the Wikitude SDK image recognition we leave `update` blank.   ```c++  ... ctor/dtor ...  void FaceDetectionPlugin::cameraFrameAvailable(const wikitude::sdk::Frame&amp; cameraFrame_) {  	wikitude::sdk::Size frameSize = cameraFrame_.getSize();     _scaledCameraFrameWidth = cameraFrame_.getScaledWidth();     _scaledCameraFrameHeight = cameraFrame_.getScaledHeight();  	std::memcpy(_grayFrame.data,cameraFrame_.getLuminanceData(), frameSize.height*frameSize.width*sizeof(unsigned char));      //... Control Open CV ...		      if ( _result.size() ) {         convertFaceRectToModelViewMatrix(croppedImg, _result.at(0));         _observer-&gt;faceDetected(_modelViewMatrix);     } else {         _observer-&gt;faceLost();     } }  void FaceDetectionPlugin::startRender() {     _observer-&gt;renderDetectedFaceAugmentation(); }  void FaceDetectionPlugin::update(const std::list&lt;wikitude::sdk::RecognizedTarget&gt; &amp;recognizedTargets_) { 	/* Intentionally Left Blank */ }  //... other internally used methods ...  ```  To render a frame around detected faces we created an instance of the `StrokedRectangle` class which takes care of rendering a rectangle around faces and all targets of the also active `ImageTracker`. When the plugin detects, looses or recalculated the projection matrix it will call the appropriate view controller methods which we use to update the `StrokedRectangle` instance. If the Plugin decides it is time to render a frame around a detected face it will call `-setFaceIsRecognized:atPosition:`. Since the plugin will only call this method in the `startRender` method, we know the current thread is the OpenGL thread and are able to dispatch OpenGL calls.  ```objc - (void)setFaceIsRecognized:(BOOL)recognized atPosition:(const float*)modelViewMatrix {     self.faceDetected = recognized;     if (recognized) {         [self.recognizedFaceRectangle setModelViewMatrix:modelViewMatrix];     } }  - (void)setFaceAugmentationProjectionMatrix:(const float*)projectionMatrix {     [self.recognizedFaceRectangle setProjectionMatrix:projectionMatrix]; } ``` "
});



documentTitles["inputpluginsapi.html#input-plugins-api"] = "Input Plugins API";
index.add({
    url: "inputpluginsapi.html#input-plugins-api",
    title: "Input Plugins API",
    body: "## Input Plugins API  This guide provides an introduction into the input plugins API of the Wikitude Native SDK and aims to familiarize the reader with its concepts and constraints. Due to the length and complexity of the corresponding example application source code, it will not be presented in its entirety. Relevant and descriptive source code examples will, however, be provided. Since the Input Plugins API is an extension to the Plugins API, we recommend familiarity with it prior to reading this guide.  1. [About Wikitude SDK Input Plugins](#about) 2. [Input Plugin Base Class](#base_class) 3. [Simple Input Plugin](#simple_input_plugin) 4. [Custom Camera](#custom_camera) 	- [Concurrency](#concurrency) 	- [OpenGL Context](#context) 	- [Device Orientation](#orientation)   &lt;a id=\&quot;about\&quot;&gt;&lt;/a&gt; "
});

documentTitles["inputpluginsapi.html#about-wikitude-sdk-input-plugins"] = "About Wikitude SDK Input Plugins";
index.add({
    url: "inputpluginsapi.html#about-wikitude-sdk-input-plugins",
    title: "About Wikitude SDK Input Plugins",
    body: "### About Wikitude SDK Input Plugins  The input plugins API provides a means to alter the inputs and outputs of the Wikitude Native SDK. For the input case specifically, custom frame data of arbitrary sources can be supplied as an input to the Wikitude SDK Native API for processing. Complementary, for the output case, the default rendering of the Wikitude SDK Native API can be substituted with more advanced implementations.  Input plugins can be registered before the SDK is started or while it is already running. In case it is registered before the Wikitude SDK is started, the internal Wikitude camera implementation is not started at all and the Wikitude SDK starts using the input plugin from the very beginning on. In case an input plugin is registered at runtime, the internal Wikitude SDK camera is first stopped, subsequently followed by a transition to the newly registered input plugin.   &lt;a id=\&quot;base_class\&quot;&gt;&lt;/a&gt; "
});

documentTitles["inputpluginsapi.html#input-plugin-base-class"] = "Input Plugin Base Class";
index.add({
    url: "inputpluginsapi.html#input-plugin-base-class",
    title: "Input Plugin Base Class",
    body: "### Input Plugin Base Class ``` class InputPlugin: public Plugin { public:     using InputFrameAvailableNotifier = std::function&lt;int(long frameId, std::shared_ptr&lt;unsigned char&gt; frameData)&gt;;  public:     InputPlugin(std::string identifier_);     virtual ~InputPlugin();      virtual bool requestsInputFrameRendering();     virtual bool requestsInputFrameProcessing();      void notifyNewInputFrame(long frameId_, std::shared_ptr&lt;unsigned char&gt; inputFrame_, bool managedFromOutside_ = false);      InputRenderSettings&amp; getRenderSettings();     InputFrameSettings&amp; getFrameSettings();     virtual void prepareRenderingOfInputFrame(long frameId_);      virtual std::shared_ptr&lt;unsigned char&gt; getPresentableInputFrameData();      virtual void internalError(const std::string&amp; errorMessage);     void setInputFrameAvailableNotifier(InputFrameAvailableNotifier newInputFrameAvailableNotifier);  private:     InputFrameAvailableNotifier                     _newInputFrameAvailableNotifier;      InputFrameRenderSettings                        _renderSettings;     InputFrameSettings                              _frameSettings;     std::unique_ptr&lt;InputFrameBufferController&gt;     _inputFrameBufferController; }; ```  The keen observer will be quick to notice that the `InputPlugin` class is derived from the `Plugin` class. This allows an `InputPlugin` to be handled in the same manner as a regular plugin; therefore `Plugin` instantiation and registration are identical and will not be discussed redundantly in this guide. Please refer to the Plugins API guide for a detailed explanation. Instead, we will focus on and demonstrate the use of the newly introduced functions.  "
});

documentTitles["inputpluginsapi.html#color-space"] = "Color Space";
index.add({
    url: "inputpluginsapi.html#color-space",
    title: "Color Space",
    body: "#### Color Space  ``` getFrameSettings.setInputFrameColorSpace(wikitude::sdk::FrameColorSpace::YUV_420_NV21); ```  The Wikitude Native SDK currently accepts RGB frame data corresponding to the `FrameColorSpace::RGB` value, as well as YUV data in 4:2:0 NV21 format corresponding to the `FrameColorSpace::YUV_420_NV21` value. The former implies a frame data size of `frameWidth * frameHeight * 3` bytes, while the latter implies a frame data size of `frameWidth * frameHeight * 3 / 2` bytes.  "
});

documentTitles["inputpluginsapi.html#field-of-view"] = "Field of View";
index.add({
    url: "inputpluginsapi.html#field-of-view",
    title: "Field of View",
    body: "#### Field of View     ``` getFrameSettings.setFrameFieldOfView([_camera fieldOfView]); ```     The `setFrameFieldOfView` function parameter needs to be a `float` value representing the horizontal field of view angle in degrees of the camera the provided frame was captured with. This value is required for the Wikitude computer vision engine to be able to accurately recognise and track targets within the provided frame. Note that the field of view value may significantly differ from device to device, we therefore recommend querying this value from the frame source directly to ensure representative values. For input image files and input video files this value should be discernible from the corresponding meta data; for an input camera stream this value should be accessible though the corresponding camera API.  "
});

documentTitles["inputpluginsapi.html#frame-size"] = "Frame Size";
index.add({
    url: "inputpluginsapi.html#frame-size",
    title: "Frame Size",
    body: "#### Frame Size   ``` getFrameSettings.setInputFrameSize({[_camera videoDimensions].width, [_camera videoDimensions].height}); ```       The `setInputFrameSize` function parameter needs to be of type `wikitude::sdk::Size&lt;int&gt;` containing the input image width and input image height in pixels. Since this value will be constant for many use cases, you may consider hard-coding it to the appropriate values. Alternatively, as with the previous function, we recommend querying the values from either the input file or the input camera device.  "
});

documentTitles["inputpluginsapi.html#default-frame-rendering"] = "Default Frame Rendering";
index.add({
    url: "inputpluginsapi.html#default-frame-rendering",
    title: "Default Frame Rendering",
    body: "#### Default Frame Rendering  ``` bool YUVFrameInputPlugin::requestsInputFrameRendering() {     return false; } ```  The `requestsInputFrameRendering` function can be overridden to provide a boolean value indicating whether the input frame data should be processed by the Wikitude SDK Native API or not. The default implementation returns true, meaning that the frame will be rendered using the internal rendering of the Wikitude SDK Native API to present the frame. Should this function be overridden to return false, the responsibility to present the frame becomes that of the `InputPlugin`.  "
});

documentTitles["inputpluginsapi.html#default-frame-processing"] = "Default Frame Processing";
index.add({
    url: "inputpluginsapi.html#default-frame-processing",
    title: "Default Frame Processing",
    body: "#### Default Frame Processing  ``` bool YUVFrameInputPlugin::requestsInputFrameProcessing() {     return true; } ```  The `requestsInputFrameProcessing` function can be overridden to provide a boolean value indicating whether the input frame data should be processed by the Wikitude computer vision engine. The default implementation returns `true`, meaning that it will be processed. The plugin will be notified of the recognition results through the update function, as is the case for the regular Plugins API. Should this function to be overridden to return `false`, the responsibility to perform the desired algorithms becomes that of the `InputPlugin`.  "
});

documentTitles["inputpluginsapi.html#supplying-image-data"] = "Supplying Image Data";
index.add({
    url: "inputpluginsapi.html#supplying-image-data",
    title: "Supplying Image Data",
    body: "#### Supplying Image Data  ``` void notifyNewInputFrame(long frameId_, std::shared_ptr&lt;unsigned char&gt; inputFrame_, bool managedFromOutside_ = false); ```  The `notifyNewInputFrame` function needs to be called to pass the actual input frame data to the Wikitude SDK Native API. It requires a unique frame identifier of `long` type to be supplied, as well as the frame data itself wrapped into a `std::shared_ptr&lt;unsigned char&gt;`. It additionally accepts a boolean value indicating whether the default frame caching should be employed or not. The parameter value defaults to `false`, meaning the Wikitude SDK Native API default caching will be used. Should you prefer to supply your own frame caching mechanism, set this value to `true`. The default caching mechanism keeps up to 5 recent frames in memory to ensure smooth processing performance. Note that you may need to invoke this method from native code due to the file resource or input stream device only being accessible therein. For this use case we recommend having a look at the custom camera sample application code of the Wikitude Native SDK example application.  "
});

documentTitles["inputpluginsapi.html#rendering-configuration"] = "Rendering Configuration";
index.add({
    url: "inputpluginsapi.html#rendering-configuration",
    title: "Rendering Configuration",
    body: "#### Rendering Configuration  ``` InputFrameRenderSettings&amp; getRenderSettings(); ```  The `getRenderSettings` function behaviour can be altered to provide a parameterised instance of type InputFrameRenderSettings. The default implementation returns the default constructed `_renderSettings` member. Should you like to provide render settings to the internal Wikitude Native SDK that differ from the default constructed values, alter the `_renderSettings` accordingly before it is returned.  "
});

documentTitles["inputpluginsapi.html#frame-caching"] = "Frame Caching";
index.add({
    url: "inputpluginsapi.html#frame-caching",
    title: "Frame Caching",
    body: "#### Frame Caching  ``` virtual void prepareRenderingOfInputFrame(long frameId_); ```  The `prepareRenderingOfInputFrame` function is called whenever a frame has been processed to report its identifier. It is, however, only called if `requestsInputFrameRendering` has been overridden to return `false` and `requestsInputFrameProcessing` has been overridden to return `true`. The default implementation of this function releases the frame indicated by the received identifier as well as any older frames from the frame cache. In case of a non-default frame caching mechanism, override this method accordingly. An input parameter of `-1` identifies the most recent frame.  "
});

documentTitles["inputpluginsapi.html#receiving-processed-frame-data"] = "Receiving Processed Frame Data";
index.add({
    url: "inputpluginsapi.html#receiving-processed-frame-data",
    title: "Receiving Processed Frame Data",
    body: "#### Receiving Processed Frame Data  ``` virtual std::shared_ptr&lt;unsigned char&gt; getPresentableInputFrameData(); ```  The `getPresentableInputFrameData` function can be called to receive the frame data of the most recently processed frame from the default frame cache. Use this method in case `requestsInputFrameRendering` has been overridden to return `false` in order to retrieve the current frame data to be rendered. When using a custom frame caching mechanism, this function is obsolete.  "
});

documentTitles["inputpluginsapi.html#error-handling"] = "Error handling";
index.add({
    url: "inputpluginsapi.html#error-handling",
    title: "Error handling",
    body: "#### Error handling  ``` virtual void internalError(const std::string&amp; errorMessage);  ```  The `internalError` function gets called whenever an internal error occurs in the Wikitude Native SDK that was not directly related to input plugins. The input parameter provides a description of the error that occurred.  "
});

documentTitles["inputpluginsapi.html#internal-use-only"] = "Internal Use Only";
index.add({
    url: "inputpluginsapi.html#internal-use-only",
    title: "Internal Use Only",
    body: "#### Internal Use Only  ``` void setInputFrameAvailableNotifier(InputFrameAvailableNotifier newInputFrameAvailableNotifier); ```  The `setInputFrameAvailableNotifier` function is called internally and should not be called anywhere else.   &lt;a id=\&quot;simple_input_plugin\&quot;&gt;&lt;/a&gt; "
});

documentTitles["inputpluginsapi.html#simple-input-plugin"] = "Simple Input Plugin";
index.add({
    url: "inputpluginsapi.html#simple-input-plugin",
    title: "Simple Input Plugin",
    body: "### Simple Input Plugin This sample shows the implementation of a custom camera whose frames are rendered by the Wikitude SDK.        The Simple Input Plugin Example consists of the C++ class `SimpleYUVInputPlugin` and the Objective-C classes `WTSimpleDeviceCamera` and `WTSimpleYUVInputCamera`. The class `WTSimpleDeviceCamera` contains a simple implementation of the AVFoundation camera API. The class `WTSimpleYUVInputCamera` creates instances of the `WTSimpleDeviceCamera` and `SimpleYUVInputPlugin` classes. It further connects both instances, so that the iOS SDK camera can be started/stopped and the frames passed to the C++ input plugin implementation.         The code to register the plugin is written in `WTSimpleInputPluginViewController.mm` file. The `WTSimpleYUVInputCamera` object is created right after the `WTWikitudeNativeSDK` object is created  ```objc self.simpleYUVInputCamera = [[WTSimpleYUVInputCamera alloc] init]; ``` and the input plugin is registered *before* the Wikitude Native SDK is started.  ```objc NSError *error = nil;     BOOL pluginRegistered = [self.wikitudeSDK registerPlugin:[_simpleYUVInputCamera cameraInputPlugin] error:&amp;error];     if ( !pluginRegistered )     {         NSLog(@\&quot;Unable to register plugin '%@'. Error: %@\&quot;, [NSString stringWithUTF8String:[_simpleYUVInputCamera cameraInputPlugin]-&gt;getIdentifier().c_str()], [error localizedDescription]);     }      [self.wikitudeSDK start:nil completion:^(BOOL isRunning, NSError * _Nonnull error) {         // ...     }]; ```  Registering an input plugin even before the Wikitude Native SDK starts indicates to the Wikitude Native SDK that the internal camera implementation is not needed and therefore also not started. This leads to a clean and fast startup of the SDK with no camera switch happening in the first frames.         The class `SimpleInputPlugin` derives from `InputPlugin` and contains the most minimalistic implementation of a input plugin for the Wikitude SDKs.  The camera lifecycle is coupled to the input plugin lifecycle methods. The following code snippets demonstrates this:  ```c++ void SimpleYUVInputPlugin::initialize() { 	/* The initialize method is used to initialize the iOS SDK camera */     _initialized = [_camera initialize];  	/* Once the camera was initialzed correctly, input frame related settings are adjusted */     if ( _initialized )     {         this-&gt;getFrameSettings().setInputFrameColorSpace(wikitude::sdk::FrameColorSpace::YUV_420_NV21);         this-&gt;getFrameSettings().setInputFrameSize({640, 480});         this-&gt;getFrameSettings().setFrameFieldOfView( [_camera fieldOfView] );     } }  void SimpleYUVInputPlugin::pause() {  	/* In case the SDK pauses (because the hosting application resignes active), also the iOS SDK camera is paused */     [_camera stopRunning];     _running = false; }  void SimpleYUVInputPlugin::resume(unsigned int pausedTime_) {  	/* Like in `pause()`, `resume()` is used to resume the iOS SDK camera */     if ( _initialized ) {         _running = [_camera startRunning];     } }  void SimpleYUVInputPlugin::destroy() { 	 	/* In case the plugin is destroyed (Which is called as soon as the plugin is unregistered and the hosting application destroyes the shared_ptr used to register the plugin), also the iOS SDK camera is released */     [_camera shutdown]; } ```  To move camera frames from Objective-C to C++, a `AVCaptureVideoDataOutputSampleBufferDelegate` object is passed to the `WTSimpleDeviceCamera` initializer which is internally passed to the `AVCaptureVideoDataOutput` `-setSampleBufferDelegate:queue` method.  The `AVCaptureVideoDataOutputSampleBufferDelegate` implementation inside the `WTSimpleYUVInputCamera` calls the user defined method `void notifyNewImageBufferData(std::shared_ptr&lt;unsigned char&gt; imageBufferData)` from the `SimpleInputPlugin` and passes a `std::shared_ptr` containing a representation of the iOS SDK camera frame. This `std::shared_ptr` is created in the `WTSimpleYUVInputCamera` class like the following:  ```objc if ( kCVReturnSuccess == CVPixelBufferLockBaseAddress(imageBuffer, kCVPixelBufferLock_ReadOnly) ) {     size_t frameDataSize = CVPixelBufferGetDataSize(imageBuffer);     std::shared_ptr&lt;unsigned char&gt; frameData = std::shared_ptr&lt;unsigned char&gt;(new unsigned char[frameDataSize], std::default_delete&lt;unsigned char[]&gt;());     std::memcpy(frameData.get(), CVPixelBufferGetBaseAddressOfPlane(imageBuffer, 0), frameDataSize);                 _cameraInputPlugin-&gt;notifyNewImageBufferData(frameData);     CVPixelBufferUnlockBaseAddress(imageBuffer, kCVPixelBufferLock_ReadOnly); } ``` Please note that a custom deleter is passed to the `std::shared_ptr` constructor in order to free the memory that was created with the `new` statement.  The implementation of `notifyNewImageBufferData` calls the `notifyNewInputFrame` method defined for input plugins. It generates a new frame id and passes the `std::shared_ptr` containing the frame data generated in Objective-C.  ```c++ void SimpleYUVInputPlugin::notifyNewImageBufferData(std::shared_ptr&lt;unsigned char&gt; imageBufferData) {     notifyNewInputFrame(++_frameId, imageBufferData); } ```  Please note that the implementation that is used here is purely for demonstration purposes. Production applications are free to implement camera access and camera frame distribution completely different.        &lt;a id=\&quot;custom_camera\&quot;&gt;&lt;/a&gt; "
});

documentTitles["inputpluginsapi.html#custom-camera"] = "Custom Camera";
index.add({
    url: "inputpluginsapi.html#custom-camera",
    title: "Custom Camera",
    body: "### Custom Camera The custom camera example illustrates both principles in a unified use case. A custom camera stream is supplied as an input and a custom rendering effect is used to augment the rendered output.  &lt;a id=\&quot;concurrency\&quot;&gt;&lt;/a&gt; "
});

documentTitles["inputpluginsapi.html#concurrency"] = "Concurrency";
index.add({
    url: "inputpluginsapi.html#concurrency",
    title: "Concurrency",
    body: "#### Concurrency  When implementing an `InputPlugin`, one needs to be aware that its callback functions are invoked concurrently by the Wikitude SDK Native API. It is therefore necessary to protect against race conditions accordingly. We will present two recommended measures to do so: atomic operations and mutual exclusion.  In order to fully utilize the capabilities of the Input Plugin API one must gather data from several asynchronously called member functions, store them, potentially as member variables, and subsequently use them collectively. These operations might be vulnerable to race conditions.  An example snippet from the custom camera example application code:  ``` void YUVFrameInputPlugin::surfaceChanged(wikitude::sdk::Size&lt;int&gt; renderSurfaceSize_, wikitude::sdk::Size&lt;float&gt; cameraSurfaceScaling_, wikitude::sdk::DeviceOrientation deviceOrientation_) {      // some orientation handling code here      _surfaceInitialized.store(true); } ```  ``` void YUVFrameInputPlugin::startRender() {     // some early exit code here      render(); } ```  ``` void YUVFrameInputPlugin::render() {      // some early exit code here      if (!_surfaceInitialized.load()) {         return;     }      // lots of OpenGL code here } ```  ``` #include &lt;atomic&gt;  std::atomic_bool _surfaceInitialized; ```  The `surfaceChanged` function and the `startRender` function are invoked concurrently. We rely on a boolean value inside the render function that is set from the `surfaceChanged` function, yielding a race condition should boolean reads and writes be non-atomic. In such cases, involving intrinsic data types for which atomic operations are provided by the C++ standard library, we recommend their use. These `std::atomics` can either be set and read intuitively through the corresponding operators or though the `load` and `store` functions.  An alternative snippet for which atomic operations are not available:  ``` void YUVFrameInputPlugin::update(const std::list&lt;wikitude::sdk::RecognizedTarget&gt;&amp; recognizedTargets_) {     // platform specific intialization code here      { // mutex auto release scope         std::lock_guard&lt;std::mutex&gt; lock(_currentlyRecognizedTargetsMutex);         _currentlyRecognizedTargets = std::list&lt;wikitude::sdk::RecognizedTarget&gt;(recognizedTargets_);     } } ```  ``` void YUVFrameInputPlugin::startRender() {     // some early exit code here      render(); } ```  ``` void YUVFrameInputPlugin::render() {     // early returns and lots of OpenGL code here      { // mutex auto release scope     std::unique_lock&lt;std::mutex&gt; lock(_currentlyRecognizedTargetsMutex);          if (!_currentlyRecognizedTargets.empty()) {             const wikitude::sdk::RecognizedTarget targetToDraw = _currentlyRecognizedTargets.front();              // early unlock to minimize locking duration             lock.unlock();              // lots of OpenGL code here         }     } }  ```  The `update` function and the `startRender` function are invoked concurrently. We, again, rely on data being set from an asynchronous function within our render function. Contrary to the previous case though, an object of type `std::list` cannot be set atomically using `std::atomics`. Therefore we employ a `std::mutex` as a locking mechanism to ensure atomicity. As depicted by the code snippet, we encourage the use of RAII style mutex locking using `std::lock_guard` and `std::unique_lock` to ensure proper mutex release.  &lt;a id=\&quot;context\&quot;&gt;&lt;/a&gt; "
});

documentTitles["inputpluginsapi.html#opengl-context"] = "OpenGL Context";
index.add({
    url: "inputpluginsapi.html#opengl-context",
    title: "OpenGL Context",
    body: "#### OpenGL Context  Another important issue to be aware of is the availability of a valid OpenGL context during plugin run-time. We guarantee such a valid context to be available during the execution of the `startRender`, `endRender`, `pause` and `resume` functions. The former two functions should contain all of the rendering related function calls, while the latter should be used to release and acquire OpenGL related resources as the OpenGL context is likely to be destroyed upon pausing the application and recreated upon resuming the application. Therefore all the previously acquired OpenGL handles are no longer valid and need to be reacquired.  A code snipped from the custom camera example:  ``` void YUVFrameInputPlugin::pause() {      releaseFramebufferObject();     releaseFrameTextures();     releaseVertexBuffers();     releaseShaderProgram();      _renderingInitialized.store(false);      // some additional code here } ```  ``` void YUVFrameInputPlugin::startRender() {     if (!_renderingInitialized.load()) {         _renderingInitialized.store(setupRendering());     }      render(); } ```  We release all the OpenGL resources we previously created and atomically set the `_renderingInitialized` flag to `false`, causing the rendering environment to be reinitialised during the next execution of the render loop.  &lt;a id=\&quot;orientation\&quot;&gt;&lt;/a&gt; "
});

documentTitles["inputpluginsapi.html#device-orientation"] = "Device Orientation";
index.add({
    url: "inputpluginsapi.html#device-orientation",
    title: "Device Orientation",
    body: "#### Device Orientation  Lastly, we will demonstrate the rendering of an input frame from within an `InputPlugin` using OpenGL with device orientations taken into account. While there are alternative ways to achieve the correctly oriented frame renderings, we recommend applying the required transformations as matrices within a custom vertex shader.  We propose the following code in our custom camera example application to compose a matrix that is to be applied to a fullscreen quad:  ``` void YUVFrameInputPlugin::surfaceChanged(wikitude::sdk::Size&lt;int&gt; renderSurfaceSize_, wikitude::sdk::Size&lt;float&gt; cameraSurfaceScaling_, wikitude::sdk::DeviceOrientation deviceOrientation_) {     wikitude::sdk::Matrix4 scaleMatrix;     scaleMatrix.scale(cameraSurfaceScaling_.width, cameraSurfaceScaling_.height, 1.0f);      switch (deviceOrientation_)     {         case wikitude::sdk::DeviceOrientation::DeviceOrientationPortrait:         {             wikitude::sdk::Matrix4 rotationToPortrait;             rotationToPortrait.rotateZ(270.0f);              _orientationMatrix = rotationToPortrait;             break;         }         case wikitude::sdk::DeviceOrientation::DeviceOrientationPortraitUpsideDown:         {             wikitude::sdk::Matrix4 rotationToUpsideDown;             rotationToUpsideDown.rotateZ(90.0f);              _orientationMatrix = rotationToUpsideDown;             break;         }         case wikitude::sdk::DeviceOrientation::DeviceOrientationLandscapeLeft:         {             wikitude::sdk::Matrix4 rotationToLandscapeLeft;             rotationToLandscapeLeft.rotateZ(180.0f);              _orientationMatrix = rotationToLandscapeLeft;             break;         }         case wikitude::sdk::DeviceOrientation::DeviceOrientationLandscapeRight:         {             _orientationMatrix.identity();             break;         }     }      _modelMatrix = scaleMatrix * _orientationMatrix;      // some synchronization code here } ```  ``` attribute vec3 vPosition; attribute vec2 vTexCoords;  varying mediump vec2 fTexCoords;  uniform mat4 uModelMatrix;  void main(void) {     gl_Position = uModelMatrix * vec4(vPosition, 1.0);     fTexCoords = vTexCoords; }\&quot;; ```  ``` struct Vertex {     GLfloat position[3];     GLfloat texCoord[2]; };  Vertex _vertices[4]; ```  ``` _vertices[0] = (Vertex){{1.0f, -1.0f, 0}, {1.0f, 0.0f}}; _vertices[1] = (Vertex){{1.0f, 1.0f, 0}, {1.0f, 1.0f}}; _vertices[2] = (Vertex){{-1.0f, 1.0f, 0}, {0.0f, 1.0f}}; _vertices[3] = (Vertex){{-1.0f, -1.0f, 0}, {0.0f, 0.0f}}; ```  The matrix composed within the `surfaceChanged` function is supplied to the vertex shader as a `uniform` parameter and subsequently used to transform the input vertices. Be aware though, that an additional matrix may be required depending on whether you previously rendered to a FBO. If so, the following amendment to the `surfaceChanged` function should correct the flipped Y-axis resulting from this process:  ``` wikitude::sdk::Matrix4 scaleMatrix; _fboCorrectionMatrix.scale(1.0f, -1.0f, 1.0f);  // same device orientation code here as depicted above  _modelMatrix = scaleMatrix * _orientationMatrix * _fboCorrectionMatrix; ```  For a complete implementation of an input plugin for a specific and advanced use case, we strongly recommend looking into the custom camera example application source code. Additionally, the custom camera sample source code is an excellent starting point to build your own implementation from. "
});



documentTitles["hardwarecontrolnative.html#hardware-control"] = "Hardware Control";
index.add({
    url: "hardwarecontrolnative.html#hardware-control",
    title: "Hardware Control",
    body: "## Hardware Control     &lt;a id=\&quot;camera_settings\&quot;&gt;&lt;/a&gt; "
});

documentTitles["hardwarecontrolnative.html#camera-settings"] = "Camera Settings";
index.add({
    url: "hardwarecontrolnative.html#camera-settings",
    title: "Camera Settings",
    body: "### Camera Settings The first part of the series will present a general overview of what is possible with the Wikitude SDK.  "
});

documentTitles["hardwarecontrolnative.html#camera-position"] = "Camera Position";
index.add({
    url: "hardwarecontrolnative.html#camera-position",
    title: "Camera Position",
    body: "#### Camera Position The camera position defines if the front, back or default camera should be started. This can be set by using [`WTNativeStartupConfiguration.captureDevicePosition`](iosnativeapi://Classes/WTStartupConfiguration.html#//api/name/captureDevicePosition) or [`WTCaptureDeviceManager.activeCaptureDevicePosition`](iosnativeapi://Classes/WTCaptureDeviceManager.html#//api/name/activeCaptureDevicePosition).  "
});

documentTitles["hardwarecontrolnative.html#camera-focus-mode"] = "Camera Focus Mode";
index.add({
    url: "hardwarecontrolnative.html#camera-focus-mode",
    title: "Camera Focus Mode",
    body: "#### Camera Focus Mode The camera focus mode defines which focus mode is used internally by the camera. It can be set by using [`WTNativeStartupConfiguration.captureDeviceFocusMode`](iosnativeapi://Classes/WTStartupConfiguration.html#//api/name/captureDeviceFocusMode) or [`WTCaptureDeviceManager.focusMode`](iosnativeapi://Classes/WTCaptureDeviceManager.html#//api/name/focusMode). The camera focus mode can be one of the following modes:  - Continuous: Is the default if the device supports it, in this mode the camera will try to refocus automatically when necessary. - Once: Can force the camera to refocus once on the current view. If you need to change focus you can set this value again. Each time the value `ONCE` is set, the camera tries to focus on the current scene again - OFF: Is disabling auto focus and will set the focus to the specified manual focus distance.  "
});

documentTitles["hardwarecontrolnative.html#manual-camera-focus"] = "Manual Camera Focus";
index.add({
    url: "hardwarecontrolnative.html#manual-camera-focus",
    title: "Manual Camera Focus",
    body: "#### Manual Camera Focus The focus distance ranges from 0 to 1 where 0 is closest focus possible and 1 is at infinity focus. It can be set by using [`WTNativeStartupConfiguration.captureDeviceFocusDistance`](iosnativeapi://Classes/WTStartupConfiguration.html#//api/name/captureDeviceFocusDistance) or [`WTCaptureDeviceManager.focusDistance`](iosnativeapi://Classes/WTCaptureDeviceManager.html#//api/name/focusDistance).  "
});

documentTitles["hardwarecontrolnative.html#camera-resolution"] = "Camera Resolution";
index.add({
    url: "hardwarecontrolnative.html#camera-resolution",
    title: "Camera Resolution",
    body: "#### Camera Resolution ![](images/advanced_camera_options_feature.jpg)  It can be set by using [`WTNativeStartupConfiguration.captureDeviceResolution`](iosnativeapi://Classes/WTStartupConfiguration.html#//api/name/captureDeviceResolution) and not be changed during runtime. The recommended values are the following:  |    Recommendations                   |  Geo        |  Image Tracking  |  Extended Tracking  |  Cloud Recognition  |  Instant Tracking  | |--------------------------------------|:-----------:|:----------------:|:-------------------:|:-------------------:|:------------------:| | [`WTCaptureDeviceResolution`](iosnativeapi://Constants/WTCaptureDeviceResolution.html) | `AUTO`    |       `AUTO`      |       `SD_640x480`    |       `SD_640x480`    |      `SD_640x480`    | This setting will only be used on armv8 devices, all other architectures will default to `SD_640x480` .  "
});

documentTitles["hardwarecontrolnative.html#camera-frame-rate"] = "Camera Frame Rate";
index.add({
    url: "hardwarecontrolnative.html#camera-frame-rate",
    title: "Camera Frame Rate",
    body: "#### Camera Frame Rate The camera frame rate can be set to either 30 or 60 fps. If 60 fps is selected the camera resolution may be changed for the 60 fps to be possible.  The first supported combination is used by the SDK:  - FullHD 60 fps - HD 60 fps - SD 60 fps - FullHD 30 fps - HD 30 fps - SD 30 fps  It can be set by using [`WTNativeStartupConfiguration.targetFrameRate`](iosnativeapi://Classes/WTStartupConfiguration.html#//api/name/targetFrameRate).  "
});

documentTitles["hardwarecontrolnative.html#camera-zoom"] = "Camera Zoom";
index.add({
    url: "hardwarecontrolnative.html#camera-zoom",
    title: "Camera Zoom",
    body: "#### Camera Zoom Digital zoom can be controlled by using [`WTCaptureDeviceManager.zoomLevel`](iosnativeapi://Classes/WTCaptureDeviceManager.html#//api/name/zoomLevel). To get the maximum zoom level use [`WTCaptureDeviceManager.maxZoomLevel`](iosnativeapi://Classes/WTCaptureDeviceManager.html#//api/name/maxZoomLevel).  "
});

documentTitles["hardwarecontrolnative.html#flashlight"] = "Flashlight";
index.add({
    url: "hardwarecontrolnative.html#flashlight",
    title: "Flashlight",
    body: "#### Flashlight The flashlight can be turned on and off by using [`WTCaptureDeviceManager.torchMode`](iosnativeapi://Classes/WTCaptureDeviceManager.html#//api/name/torchMode).       &lt;a id=\&quot;CameraControlsiOS\&quot;&gt;&lt;/a&gt; "
});

documentTitles["hardwarecontrolnative.html#camera-controls"] = "Camera Controls";
index.add({
    url: "hardwarecontrolnative.html#camera-controls",
    title: "Camera Controls",
    body: "### Camera Controls  The `WTCaptureDeviceManager` allows you to change capture device specific settings during an active capture session. It lets you change e.g.  	* the capture device position 	* the capture device focus mode 	* the capture device focus distance 	* the capture device zoom level 	 A valid pointer to a `WTCaptureDeviceManager` object can be retrieved from the `WTWikitudeNativeSDK` method `-captureDeviceManager`. Please note that this pointer is only valid if the native SDK is running. If the SDK is currently stopped, changes for the capture device are done using the `WTStartupConfiguration` object that is passed as argument to the startupHandler when calling `-start:completion:`.  The sample uses a `UIPickerView` to let the user select between different camera specific values. This `UIPickerView` is added to the view hierarchy in the main storyboards camera scene. By default, the picker view is placed behind the OpenGL ES 2 view, so that it is not visible. To show the picker view, the bottom OpenGL ES 2 view constraint is modified and animated, if a button is touched, to unveil the picker view. A standard iOS SDK UIView animation is used to do so. Please refer to the `WTCameraControlsViewController` `-handleCameraControlsPresentation` method.  The connection between the `UIPickerView` and `WTCaptureDeviceManager` is done by a custom class called `WTCameraControlsModel` and its delegate object (Which is in this case `WTCameraControlsViewController`). This custom class `WTCameraControlsModel` implements the `UIPickerView` data source and delegate protocol and uses its custom delegate object to retrieve current camera specific values or exposes newly selected values from the picker view.  Implementation details of `WTCameraControlsModel` are not discussed in this guide as it only handles UIKit related functionality. The following snippets shows the previously mentioned object connection. All following snippets can be found in the `WTCameraControlsViewController` class.  ```objc self.cameraControlsPickerModel = [[WTCameraControlsModel alloc] init]; self.cameraControlsPickerModel.delegate = self; self.cameraControlPicker.dataSource = _cameraControlsPickerModel; self.cameraControlPicker.delegate = _cameraControlsPickerModel; ```  The camera controls model knows internally about all possible camera settings and uses these information to load the picker view. Once the picker is loaded and the user selects a different value, the camera controls model delegate is used to propagate the value change. Since the camera controls view controller implements this delegate protocol and also holds a reference to the Wikitude Native SDK, which by itself provides access to the capture device manager), the view controller sets the appropriate capture device value when this camera controls model delegate is called. The following snippet demonstrates this for the capture device position:  ```objc - (void)cameraControlsModel:(WTCameraControlsModel *)cameraControlsModel didSelectCameraPosition:(AVCaptureDevicePosition)activeCameraPosition {     if ( [self.wikitudeSDK captureDeviceManager] ) {         [[self.wikitudeSDK captureDeviceManager] setActiveCaptureDevicePosition:activeCameraPosition];     } } ``` Please note that there is a nil check when `[self.wikitudeSDK captureDeviceManager]` is called. This is because the Wikitude Native SDK could be paused when the picker changes one of its values.  Every time the picker becomes visible again, the camera controls model asks through its delegate object which capture device settings are currently active. The following snippet again demonstrates this for the currently active capture device position.  ```objc - (AVCaptureDevicePosition)currentlyActiveCameraPositionForCameraControlsModel:(WTCameraControlsModel *)cameraControlsModel {     return [[self.wikitudeSDK captureDeviceManager] activeCaptureDevicePosition]; } ``` "
});



documentTitles["toolsnative.html#wikitude-2d-tracking"] = "Wikitude 2D Tracking";
index.add({
    url: "toolsnative.html#wikitude-2d-tracking",
    title: "Wikitude 2D Tracking",
    body: "# Wikitude 2D Tracking  In this section of the documentation we are covering tools shipped with the Wikitude SDK, which help you in your development.   3. [Target Manager](targetmanagement.html#target-management) 4. [Best practice for target images](targetguide.html) "
});



documentTitles["targetmanagement.html#target-management"] = "Target Management";
index.add({
    url: "targetmanagement.html#target-management",
    title: "Target Management",
    body: "## Target Management   This guide gives you an overview of how to create a target collection that you can use to detect and track images within your augmented reality experience.  In general the conversion can be done via four different tools:  1. **[Wikitude Studio Manager](#wikitude-studio-manager)**: A browser based tool to convert your images to a wtc file. You can find the tool under:  &lt;a href=\&quot;https://targetmanager.wikitude.com\&quot; target=\&quot;_blank\&quot;&gt;https://targetmanager.wikitude.com&lt;/a&gt;. You need your free developer account to log-in. This tool is described in more detail further below. 2. **WTC Editor within Unity Editor**: The Wikitude Unity plugin installs a WTC Editor as extension of the Unity Editor. Unity developers can manage all their targets and target collections directly within Unity Editor. Please consult the Unity documentation on more details. 2. **RESTful API**: The Cloud Recognition Manager API provides a RESTful API to upload target images and convert them to wtc files. Read more details in the [section about Cloud Recognition API](cloudrecognitionworkflow.html#generate-a-wtc-file) 3. **Targets Enterprise Script**: A binary shell script available for Mac OS X and Linux converting images to target collections. Pleases [contact Wikitude Sales](mailto:sales@wikitude.com) team for technical requirements and pricing.  The following images describes the relationship between the above mentioned methods and the Wikitude Cloud Recognition Service, which is not scope of this documentation.   &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/150212_WT_Infografik_OfflineOnlineRecognition_01.jpg\&quot;&gt;   "
});

documentTitles["targetmanagement.html#wikitude-studio-manager"] = "Wikitude Studio Manager";
index.add({
    url: "targetmanagement.html#wikitude-studio-manager",
    title: "Wikitude Studio Manager",
    body: "## Wikitude Studio Manager  "
});

documentTitles["targetmanagement.html#add-a-new-project"] = "Add a new project";
index.add({
    url: "targetmanagement.html#add-a-new-project",
    title: "Add a new project",
    body: "### Add a new project  - Open &lt;a href=\&quot;https://targetmanager.wikitude.com\&quot; target=\&quot;_blank\&quot;&gt;https://targetmanager.wikitude.com&lt;/a&gt; and login with your Wikitude developer account - Add a new project to your project collection  &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/tmt_CreateProject.png\&quot;&gt;  "
});

documentTitles["targetmanagement.html#add-target-images"] = "Add target images";
index.add({
    url: "targetmanagement.html#add-target-images",
    title: "Add target images",
    body: "### Add target images  - Enter an existing project  - Add new target images to the project either by clicking on `Add Targets` or drag  &amp; drop them on the empty area. Supported file formats include PNG and JPEG. If you are using PNG images, please make sure that it does not contain any transparent pixels, only solid coloured images are supported.  &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/tmt_AddTargets.png\&quot;&gt;	  - When uploading a target the file name is used as `target name`. It identifies a target in your experience. If the `target name` is not completely visible, hover over it to reveal the full name or double click the target to enter edit-mode.  &lt;div class=\&quot;warning\&quot;&gt; **Important** &lt;br /&gt; If you add your own target images  you need the target name to set them in [`AR.ImageTrackable`](architectapi://reference/classes/ImageTrackable.html).&lt;/div&gt;   "
});

documentTitles["targetmanagement.html#star-rating"] = "Star Rating";
index.add({
    url: "targetmanagement.html#star-rating",
    title: "Star Rating",
    body: "### Star Rating - **0 stars:** Not suitable for tracking. This target image cannot be tracked because it lacks textured features with high local contrast. Please consider choosing another target image. - **1 star:**  Limited tracking ability. This target image provides basic tracking performance in good lightning conditions. Please consider improving the image - **2 stars:** Good tracking ability. This target image will track well in most conditions. - **3 stars:** Very good tracking ability. This target image will track very well in most conditions.  General advice for reference images  - Good image characteristics: 	- Diversely textured image with high local contrast - Bad image characteristics: 	- Large areas with solid color or smooth color transitions 	- Repetitive patterns 	- Logos, signs		  "
});

documentTitles["targetmanagement.html#create-a-wtc-file"] = "Create a WTC file";
index.add({
    url: "targetmanagement.html#create-a-wtc-file",
    title: "Create a WTC file",
    body: "### Create a WTC file  - AR.TargetCollectionResource WTC (Wikitude Target Collection) file which contains all information of the targets that should be recognized. Enter the project you need the file for and click the *WTC icon* in the toolbar.  &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/tmt_CreateTargetCollection.png\&quot;&gt;  - Select the Wikitude SDK version you're using and click *Generate* to trigger the creation of the WTC file. You will be notified via e-Mai once the file is available for download.  &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/tmt_TargetCollections.png\&quot;&gt;       "
});

documentTitles["targetmanagement.html#use-projects-wtc-file-in-your-app"] = "Use project's WTC file in your app";
index.add({
    url: "targetmanagement.html#use-projects-wtc-file-in-your-app",
    title: "Use project's WTC file in your app",
    body: "### Use project's WTC file in your app   Look at one of the [client recognition examples](clientrecognitionnative.html) or refer to the relevant reference for instructions on how to use the created target collection for augmentations in your ARchitect Worlds.  "
});

documentTitles["targetmanagement.html#cloud-recognition"] = "Cloud Recognition";
index.add({
    url: "targetmanagement.html#cloud-recognition",
    title: "Cloud Recognition",
    body: "### Cloud Recognition  Any existing project may also be published to the Cloud to make it accessible for [`AR.CloudRecognitionService`] (architectapi://reference/classes/CloudRecognitionService.html).  Click the *Cloud icon* in the toolbar for more details.  &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/tmt_CloudIcon.png\&quot;&gt;  Cloud Recognition is available for free in your testing process but you must purchase a license for productive use. [Learn more](http://www.wikitude.com/external/doc/documentation/latest/cloudrecognition/gettingstartedcloudrecognition.html#quota-and-limits)  &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/tmg_CloudPublishing.png\&quot;&gt;  Once a project is published it is accessible via Wiktiude SDK using 'Client Token' and 'Target Collection ID' (compare [`AR.CloudRecognitionService`](architectapi://reference/classes/CloudRecognitionService.html))  &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/tmt_CloudTracker.png\&quot;&gt;  Hints  - You may unpublish a project at any time but be aware that this action has immediate effect on your application(s) making use of the credentials.  - **Metadata** in the 'Edit Target' dialog is solely relevant for Cloud Recognition whereat **Physical Height** is only relevant for distanceToTarget feature.  - Leave **Physical Height** empty if you do not use the distanceToTarget feature of [`AR.ImageTrackable`](architectapi://reference/classes/ImageTrackable.html).  - The **Metadata** field is very useful. It allows you to attach JSON data to a target. That way you can define any kind of additional data and react on it dynamically in the SDK to e.g. let a button refer to a details page which is defined in the Metadata JSON.  &lt;img style=\&quot;width: 500px\&quot; src=\&quot;images/tmt_CloudTargetEdit.png\&quot;&gt;   "
});

documentTitles["targetmanagement.html#targets-versioning"] = "Targets Versioning";
index.add({
    url: "targetmanagement.html#targets-versioning",
    title: "Targets Versioning",
    body: "### Targets Versioning Over time the format and the capabilities of Wikitudes target collection data format have changed. The following table summarizes which version of the Wikitude SDK can handle which wtc version. Wikitude Studio Manager is capable of producing wtc files compatible with all mentioned versions. If you need to re-create a target collection go there and select the appropriate SDK version.  &lt;table&gt;     &lt;tr&gt;         &lt;th&gt;&lt;/th&gt;         &lt;th&gt;Wikitude SDK 3.x&lt;/th&gt;         &lt;th&gt;Wikitude SDK 4.0&lt;/th&gt;         &lt;th&gt;Wikitude SDK 4.1&lt;/th&gt;         &lt;th&gt;Wikitude SDK 5.0&lt;/th&gt;         &lt;th&gt;Wikitude SDK 5.1-5.3&lt;/th&gt;         &lt;th&gt;Wikitude SDK 6.0&lt;/th&gt;     &lt;/tr&gt;     &lt;tr&gt;         &lt;td&gt;wtc&amp;nbsp;3.x&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;     &lt;/tr&gt;     &lt;tr&gt;         &lt;td&gt;wtc&amp;nbsp;4.0&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;          &lt;/tr&gt;      &lt;tr&gt;         &lt;td&gt;wtc&amp;nbsp;4.1&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;         &lt;/tr&gt;      &lt;tr&gt;         &lt;td&gt;wtc&amp;nbsp;5.0&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;not-supported\&quot;&gt;not supported&lt;/td&gt;         &lt;td class=\&quot;supported\&quot;&gt;supported&lt;/td&gt;          &lt;/tr&gt; &lt;/table&gt;         "
});



documentTitles["targetguide.html#best-practice-for-target-images"] = "Best practice for target images";
index.add({
    url: "targetguide.html#best-practice-for-target-images",
    title: "Best practice for target images",
    body: "## Best practice for target images  This guide gives you an overview of how to create a target collection that you can use to detect and track images within your ARchitect World.  "
});

documentTitles["targetguide.html#summary"] = "Summary";
index.add({
    url: "targetguide.html#summary",
    title: "Summary",
    body: "### Summary  **Preferred images have:**  - between 500 to 1000 pixels in each dimension - Rich contrast - Evenly distributed textured areas - Many corner like structures  **Unsuitable images have:**  - Smaller dimensions than 500 pixels - Larger than 1000 pixels as they do not provide more accurate results - Large amounts of text - Many repetitive patterns - Large single-colored areas  - Color contrast only e.g. green to red edge), because all images are processed as grayscale images   "
});

documentTitles["targetguide.html#optimal-image-dimensions"] = "Optimal Image Dimensions";
index.add({
    url: "targetguide.html#optimal-image-dimensions",
    title: "Optimal Image Dimensions",
    body: "### Optimal Image Dimensions  - Optimal images are sized between 500 and 1000 pixels in each dimension - Small images do not contain enough graphical information to extract so called feature points. The uniqueness, amount and distribution of features points are the key indicators for good detection and tracking quality - Larger images do not improve the tracking quality ![Target image too small](images/guide_dimension_wrong.png) ![Optimal size of target image](images/guide_dimension_good.png)  "
});

documentTitles["targetguide.html#low-contrast-images"] = "Low contrast images";
index.add({
    url: "targetguide.html#low-contrast-images",
    title: "Low contrast images",
    body: "### Low contrast images  - Images with high local contrast and large amount of rich textured areas is best suited for reliable detection and tracking - Color contrast only (i.e. green to red edge) appears as high contrast to the human eye but is not discriminative to computer vision algorithms as they are operating on grayscale images ***Tip***: For low contrast images, try to increase the contrast of your target image with an image editing tool like Gimp or PhotoShop to improve detection and tracking quality  ![Target image with low contrast](images/low_contrast_wrong.png) ![Target image with good contrast](images/low_contrast_good.png)  "
});

documentTitles["targetguide.html#distribution-of-textured-areas"] = "Distribution of textured areas";
index.add({
    url: "targetguide.html#distribution-of-textured-areas",
    title: "Distribution of textured areas",
    body: "### Distribution of textured areas  - Images with evenly distributed textured areas are good candidates for reliable detection and tracking - This might be the hardest part to be in control of and often can’t be changed. ***Tip***: Try to crop the most prominent part of your image and use only this as target image.  ![Target image with not optimal distribution](images/texture_distribution_wrong.png) ![Even distribution of features](images/texture_distribution_good.png)  "
});

documentTitles["targetguide.html#images-with-whitespace"] = "Images with whitespace";
index.add({
    url: "targetguide.html#images-with-whitespace",
    title: "Images with whitespace",
    body: "### Images with whitespace  - Single-colored areas or smooth color transitions often found in backgrounds do not exhibit graphical information suitable for detection and tracking.  ***Tip***: Try to crop the most prominent part of your image and use only this as target image.  ![Too much whitespace](images/whitespace_wrong.png) ![Image reduced to the most relevant part](images/whitespace_good.png)  "
});

documentTitles["targetguide.html#vector-based-graphics"] = "Vector-based graphics";
index.add({
    url: "targetguide.html#vector-based-graphics",
    title: "Vector-based graphics",
    body: "### Vector-based graphics   - Logos and vector-based graphics usually consist of very few areas with high local contrast and textured structures and are therefore hard to detect and track.   ***Tip***: Try to add additional elements to the graphic like your logotype or any other specific elements, which can go along with your graphic.  ![Vector-based image](images/vector_wrong.png) ![Target image mixed with graphic elements](images/vector_good.png)  "
});

documentTitles["targetguide.html#images-with-a-lot-of-text"] = "Images with a lot of text";
index.add({
    url: "targetguide.html#images-with-a-lot-of-text",
    title: "Images with a lot of text",
    body: "### Images with a lot of text - Images consisting primarily of large areas of text are hard to detect and track.  ***Tip***: Try to have at least some graphical material and images next to your text for your target image.  ![Pure text](images/text_wrong.png) ![Text mixed with graphic elements](images/text_good.png)  "
});

documentTitles["targetguide.html#repetitive-patterns"] = "Repetitive patterns";
index.add({
    url: "targetguide.html#repetitive-patterns",
    title: "Repetitive patterns",
    body: "### Repetitive patterns  - Repetitive patterns exhibit the same graphical information information at each feature point and therefore cannot be localized reliably - Images with slightly irregular structures can convey a similar information to the target audience while providing enough unique feature points to be detected (second image)  ***Tip***: Try a different selection of your image including non pattern parts or use images with irregular patterns  ![Repetitive patterns that do not track](images/patterns_wrong.png) ![Pattern with irregular structures](images/patterns_good.png)       "
});



documentTitles["targetimages.html#target-images"] = "Target Images";
index.add({
    url: "targetimages.html#target-images",
    title: "Target Images",
    body: "## Target Images  "
});

documentTitles["targetimages.html#all-samples"] = "All samples";
index.add({
    url: "targetimages.html#all-samples",
    title: "All samples",
    body: "### All samples   &lt;a href='images/wikitude_sample_app_target_images.zip'&gt;Click here to download all target images&lt;/a&gt;  &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/magazine_page_one.jpeg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='imagerecognition.html'&gt;Image Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/magazine_page_two.jpeg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='imagerecognition.html'&gt;Image Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/target_face.jpeg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='advancedimagerecognition.html'&gt;Image Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/iot_target.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='imagerecognition.html'&gt;Client Extended Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/schloss_johannisberg.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='cloudrecognition.html'&gt;Cloud Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/brazil.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='cloudrecognition.html'&gt;Cloud Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/barone.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='cloudrecognition.html'&gt;Cloud Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/etiquette_ermitage.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='cloudrecognition.html'&gt;Cloud Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/gw_bf2011.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='cloudrecognition.html'&gt;Cloud Recognition&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/carAd.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='3dmodels.html'&gt;3D models&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/solar_system.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='solarsystemir.html'&gt;Solar System (IR)&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/ir_geo_poster.jpg\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group1\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='2dtrackingandgeo.html#combine-client-recognition-and-pois'&gt;Combine Client Recognition and POIs&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/barcode_wikitude.png\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group2\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='pluginsapi.html'&gt;Plugins API barcode reader&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/hello_wikitude_qr.png\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group2\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='pluginsapi.html'&gt;Plugins API QR reader&lt;/a&gt;\&quot;&gt; &lt;img class=\&quot;jslghtbx-thmb\&quot; src=\&quot;images/arcuo_marker.png\&quot; data-jslghtbx data-jslghtbx-group=\&quot;group2\&quot; data-jslghtbx-caption=\&quot;Sample: &lt;a href='pluginsapi.html'&gt;Plugins API QR reader&lt;/a&gt;\&quot;&gt;  "
});



documentTitles["gettingstartedcloudrecognition.html#wikitude-cloud-recognition"] = "Wikitude Cloud Recognition";
index.add({
    url: "gettingstartedcloudrecognition.html#wikitude-cloud-recognition",
    title: "Wikitude Cloud Recognition",
    body: "# Wikitude Cloud Recognition  &lt;p class='intro' markdown='1'&gt;The Wikitude Cloud Recognition service is a cloud-based service provided by Wikitude, which recognizes images sent from Android and iOS apps using the Wikitude SDK. The recognized images are then tracked in the live camera feed and can be used for augmented reality experiences.&lt;/p&gt;  This documentation focuses on the RESTful API called Manager API, which is used to interact on a backend level with the Cloud Recognition service.   "
});

documentTitles["gettingstartedcloudrecognition.html#general-definitions"] = "General Definitions";
index.add({
    url: "gettingstartedcloudrecognition.html#general-definitions",
    title: "General Definitions",
    body: "## General Definitions  - **Target**: An image and its associated extracted data that is used to recognize an image.  - **Target Collection**: A group of `targets` that are searched together. Think of it as a directory, which contains all your images you want to search. The Wikitude SDK can work with two different sorts of `TargetCollections` 	+ On-device Target Collection: a static `wtc` file containing the extracted data of your images. Can consist of up to 1,000 images. 	+ Cloud Target Collection: A target collection stored on the Wikitude server. See `Cloud Archive` below.   - **Cloud Archive**: An archive stored on the server that is optimized for cloud-based recognition. It is generated from a `TargetCollection` and is used in combination with the Wikitude SDK [`AR.CloudRecognitionService`](architectapi://reference/classes/CloudRecognitionService.html).  **Manager API**: A RESTful web API allowing developers to interact with the Cloud Recognition server for managing `Targets`, `TargetCollections` and `Cloud Archives`. Only you as a developer uses this API. None of your users of your app will interact with this API.  **Client API**: The Client API is the interface between the Wikitude SDK and the Cloud Recognition Service. The API itself is encapsulated in the Wikitude SDK class [`AR.CloudRecognitionService`](architectapi://reference/classes/CloudRecognitionService.html) and not directly accessible. Calls on the client API are called `Scans`.  **Region**: Wikitude is providing several hosting locations for its Cloud Recognition services to cut down unwanted network latency. As a developer you need to choose on which `Region` you and your customers want to operate.   "
});

documentTitles["gettingstartedcloudrecognition.html#getting-started-with-the-cloud-recognition-service"] = "Getting Started with the Cloud Recognition Service";
index.add({
    url: "gettingstartedcloudrecognition.html#getting-started-with-the-cloud-recognition-service",
    title: "Getting Started with the Cloud Recognition Service",
    body: "## Getting Started with the Cloud Recognition Service  "
});

documentTitles["gettingstartedcloudrecognition.html#regional-availability-of-wikitude-cloud-recognition-service"] = "Regional availability of Wikitude Cloud Recognition Service";
index.add({
    url: "gettingstartedcloudrecognition.html#regional-availability-of-wikitude-cloud-recognition-service",
    title: "Regional availability of Wikitude Cloud Recognition Service",
    body: "### Regional availability of Wikitude Cloud Recognition Service  As as a developer using Wikitude Cloud Recognition Service you need to choose which server location you want to use for your projects. Wikitude operates several servers running Wikitude Cloud Recognition Service in different locations world-wide.  As the region servers are separated, content which is stored on one region server is only available on this particular server. **Content is not synced across regions**. You can choose from the following `Regions`  - `Americas` - `China` - `Europe`  The servers for each region have separate dedicated domain names and therefore different configurations.   &lt;a id=\&quot;targetmanagerregional\&quot;&gt;&lt;/a&gt;  | Region | Target Manager | Manager API| SDK Setting | | :------------------ |:---------------:| ------ | ---- | |Americas|[targetmanager&amp;#8209;us.wikitude.com](https://targetmanager-us.wikitude.com)|[https://api-us.wikitude.com](https://api-us.wikitude.com)|`Americas`| |China|[targetmanager&amp;#8209;cn.wikitude.com](https://targetmanager-cn.wikitude.com)|[https://api-cn.wikitude.com](https://api-cn.wikitude.com)|`China`| |Europe|[targetmanager.wikitude.com](https://targetmanager.wikitude.com)|[https://api.wikitude.com](https://api.wikitude.com) or [https://api-eu.wikitude.com](https://api-eu.wikitude.com)|`Europe`|  "
});

documentTitles["gettingstartedcloudrecognition.html#preparation"] = "Preparation";
index.add({
    url: "gettingstartedcloudrecognition.html#preparation",
    title: "Preparation",
    body: "### Preparation        1. [Create a free](http://www.wikitude.com/c/portal/login?p_l_id=533165) Wikitude developer account or [log-in](http://www.wikitude.com/c/portal/login?p_l_id=533165) if you are a returning developer 2. Get the [API tokens](http://www.wikitude.com/developer/licenses) for the Manager API and the Client API to start your project. [Read more on authentication](#authentication) 3. Test the API for free using Wikitude's [sample integrations](https://github.com/Wikitude/wikitude-cloud-recognition-api-samples) 4. Once you finished your integration, [purchase](https://www.wikitude.com/products/wikitude-cloud-recognition/) a commercial token.   "
});

documentTitles["gettingstartedcloudrecognition.html#first-steps-and-general-usage"] = "First Steps and General Usage";
index.add({
    url: "gettingstartedcloudrecognition.html#first-steps-and-general-usage",
    title: "First Steps and General Usage",
    body: "### First Steps and General Usage   1. Get familiar with the Manager API calls in the [API Reference](cloudrecoapi://index.html).  2. Create a first Target Collection using the [`Create Target Collection`](cloudrecoapi://index.html#api-TargetCollection-CreateTargetCollection) endpoint and note down the ID of the Target Collection	 3. Create targets using the [`Create Target`](cloudrecoapi://index.html#api-Target-CreateTarget) endpoint for that particular Target Collection 4. Important: [`Generate a Cloud Archive`](index.html#api-TargetCollection-GenerateCloudArchive) for your Target Collection 4. Go to the Wikitude SDK and create an Android or iOS project 5. Use the Client API token to authenticate your Android or iOS project 6. Use your Target Collection ID to recognize images  For more information on the available endpoints and how to work with the Manager API see the [workflow section](cloudrecognitionworkflow.html).  Instead of creating a `TargetCollection`, adding one or more `Targets`, and generating a `Cloud Archive` by calling the REST API, the [Wikitude Targetmanager](#targetmanagerregional) can be used to perform these steps (1-4) in the browser alternatively.  In case you would like to immediately test the API calls we recommend the tool [Postman](https://www.getpostman.com/). It helps you to quickly construct the requests and analyze the responses.  "
});

documentTitles["gettingstartedcloudrecognition.html#authentication"] = "Authentication";
index.add({
    url: "gettingstartedcloudrecognition.html#authentication",
    title: "Authentication",
    body: "## Authentication  The Cloud Recognition Service knows two authentication tokens, that you need in order to work with the service  * **Manager API token** You need this token to authenticate yourself against the RESTful Manager API. The Manager API is used to create, add and delete targets and target collections. The token identifies your developer account. Calls to the Manager API do not count towards your quota limits.  * **Client API token** You need this token to authenticate calls from the Wikitude SDK to the Cloud Recognition services. It again authenticates calls as legitimate. The token is bound to your developer account. Calls from the Wikitude SDK to the service with a wrong or missing token can not access your target collections.   "
});

documentTitles["gettingstartedcloudrecognition.html#authentication-on-the-manager-api"] = "Authentication on the Manager API";
index.add({
    url: "gettingstartedcloudrecognition.html#authentication-on-the-manager-api",
    title: "Authentication on the Manager API",
    body: "### Authentication on the Manager API  The **Manager API token** must be added to each call towards the Wikitude Cloud Recognition Manager API. The token authenticates the user account that is using the API.   "
});

documentTitles["gettingstartedcloudrecognition.html#authentication-on-the-client-api"] = "Authentication on the Client API";
index.add({
    url: "gettingstartedcloudrecognition.html#authentication-on-the-client-api",
    title: "Authentication on the Client API",
    body: "### Authentication on the Client API The **Client API token** must be added to your app project using the Wikitude SDK. This token is needed additionally beside the SDK license key when working with the [`AR.CloudRecognitionService`](architectapi://reference/classes/CloudRecognitionService.html) class.  "
});

documentTitles["gettingstartedcloudrecognition.html#quota-and-limits"] = "Quota and Limits";
index.add({
    url: "gettingstartedcloudrecognition.html#quota-and-limits",
    title: "Quota and Limits",
    body: "## Quota and Limits  "
});

documentTitles["gettingstartedcloudrecognition.html#general-upload-limit"] = "General Upload Limit";
index.add({
    url: "gettingstartedcloudrecognition.html#general-upload-limit",
    title: "General Upload Limit",
    body: "### General Upload Limit The Wikitude Cloud Recognition **will not accept images bigger than 1024kB** (1 MB). Trying to upload images exceeding this file size will result in a HTTP status code `400` together with an error message `FILE_SIZE_LIMIT_EXCEED`.  "
});

documentTitles["gettingstartedcloudrecognition.html#limits-for-the-wikitude-cloud-recognition-service"] = "Limits for the Wikitude Cloud Recognition Service";
index.add({
    url: "gettingstartedcloudrecognition.html#limits-for-the-wikitude-cloud-recognition-service",
    title: "Limits for the Wikitude Cloud Recognition Service",
    body: "### Limits for the Wikitude Cloud Recognition Service  There are two main limitations for the Wikitude Cloud Recognition service that you need to be aware of:  * **Targets** Your token has a certain number of targets that you can upload and store on the cloud service under your developer account. The limit is always counted for your entire developer account and not for a single target collection. The service is not counting single uploads, but how many targets are currently stored in target collections under your account.   * **Scans** Scans are in effect calls from the Wikitude SDK via the Client API to the Cloud Recognition servers. All commercial license come with an allowance of 1,000,000 scans per month per developer account. **Note:** When using Continuous Search mode multiple calls are made to the server.  "
});

documentTitles["gettingstartedcloudrecognition.html#maximum-number-of-targets-in-a-target-collection"] = "Maximum Number of Targets in a Target Collection";
index.add({
    url: "gettingstartedcloudrecognition.html#maximum-number-of-targets-in-a-target-collection",
    title: "Maximum Number of Targets in a Target Collection",
    body: "### Maximum Number of Targets in a Target Collection A target collection can't exceed 50,000 targets.  "
});

documentTitles["gettingstartedcloudrecognition.html#free-trial-license-for-cloud-recognition"] = "Free Trial License for Cloud Recognition";
index.add({
    url: "gettingstartedcloudrecognition.html#free-trial-license-for-cloud-recognition",
    title: "Free Trial License for Cloud Recognition",
    body: "### Free Trial License for Cloud Recognition  Wikitude provides a trial token for each developer account to try out the Cloud Recognition for free. This trial token has set a quota limit that allows developers to try and test the functionality of the service. Limitations for trial accounts  * Targets: 50,000 * Scans: 1,000 per month  To get your trial token for the REST API, please visit the [License page](http://www.wikitude.com/developer/licenses). The trial token is directly integrated into the Studio Manager.  "
});

documentTitles["gettingstartedcloudrecognition.html#commercial-licenses"] = "Commercial Licenses";
index.add({
    url: "gettingstartedcloudrecognition.html#commercial-licenses",
    title: "Commercial Licenses",
    body: "### Commercial Licenses For production systems, we offer commercial licenses with various quota limits for [purchase](https://www.wikitude.com/store).   "
});



documentTitles["cloudrecognitionworkflow.html#your-first-target-collections"] = "Your first Target Collections";
index.add({
    url: "cloudrecognitionworkflow.html#your-first-target-collections",
    title: "Your first Target Collections",
    body: "## Your first Target Collections Target Collections are central to working with Cloud Recognition service. They keep all your target images and are the base for the cloud archive.  Think of TargetCollection as a directory, where your images are stored. A TargetCollection forms a logical group, which is searched as a whole. Of course you can have several TargetCollections in your account, each consisting up to 50,000 images each.     "
});

documentTitles["cloudrecognitionworkflow.html#what-is-the-difference-between-cloud-archive-and-target-collection"] = "What is the difference between Cloud Archive and Target Collection";
index.add({
    url: "cloudrecognitionworkflow.html#what-is-the-difference-between-cloud-archive-and-target-collection",
    title: "What is the difference between Cloud Archive and Target Collection",
    body: "### What is the difference between Cloud Archive and Target Collection  &lt;div class=\&quot;warning\&quot;&gt;A Cloud Archive is an optimized version of your Target Collection for cloud-based recognition. Cloud Archives are in internal structure, that keeps all necessary data for performing image recognition on the server. &lt;/div&gt;  "
});

documentTitles["cloudrecognitionworkflow.html#structure-of-a-targetcollection"] = "Structure of a TargetCollection";
index.add({
    url: "cloudrecognitionworkflow.html#structure-of-a-targetcollection",
    title: "Structure of a TargetCollection",
    body: "### Structure of a TargetCollection  | Property | Type | Description| | :------------------ |:---------------| ------ | |**id**| (String)| An ID that uniquely identifies the TargetCollection| | **name** | (String) | The Name of the TargetCollection, as defined by the user| | **creDat** | (Number)| A timestamp when the TargetCollection was created (as returned by JavaScript's `Date.now()` function)| | **modDat** | (Number)| A timestamp when the TargetCollection was last modified (as returned by JavaScript's `Date.now()` function)|   "
});

documentTitles["cloudrecognitionworkflow.html#create-a-target-collection"] = "Create a Target Collection";
index.add({
    url: "cloudrecognitionworkflow.html#create-a-target-collection",
    title: "Create a Target Collection",
    body: "### Create a Target Collection  Creating a Target Collection is easy and can be done without any prerequisites in your account. In general it is your starting point and most likely your very first action.  Call the endpoint (using the domain of one of the [regional servers](gettingstartedcloudrecognition.html#targetmanagerregional))  	/cloudrecognition/targetCollection  with the mandatory `name` field as a `POST` request and you will create a new TargetCollection. The response will contain a TargetCollection object, where the ID is most important parameter. You can also add `metadata` to a TargetCollection in case you want to some additional descriptive information. The next step is to add images to your TargetCollection, so they can be recognized.  "
});

documentTitles["cloudrecognitionworkflow.html#add-target-images"] = "Add Target Images";
index.add({
    url: "cloudrecognitionworkflow.html#add-target-images",
    title: "Add Target Images",
    body: "## Add Target Images  A Target is an plain image that can be recognized by the Wikitude Cloud Recognition service. Adding or creating a target means to provide a URL to your image to the server, which then downloads the image, analyzes it  and adds it to the TargetCollection. To add an image call the endpoint  	/cloudrecognition/targetCollection/:tcId/target  with the `ID` of the TargetCollection, where you want to add the image. You need to add the a field `imageUrl` to your request. The image must be publicly accessible.  Pay attention to the optional fields `name` and `metadata`. `name` is a unique identifier for your target within the TargetCollection. It is up to you to set and use this. The same is true for the `metadata` object, which takes a full JSON object and can be filled with any value you like. The `metadata` object will be present in the recognition response.   &lt;div class=\&quot;tip\&quot;&gt;&lt;strong&gt;Important: &lt;/strong&gt;You are not done yet. As a next step you need to Generate the Cloud Archive of your TargetCollection.&lt;/div&gt;  "
});

documentTitles["cloudrecognitionworkflow.html#structure-of-a-target"] = "Structure of a Target";
index.add({
    url: "cloudrecognitionworkflow.html#structure-of-a-target",
    title: "Structure of a Target",
    body: "### Structure of a Target  | Property | Type | Description| | :------------------ |:---------------| ------ | |id |(String)| An ID that uniquely identifies the Target| |name |(String)| The Name of the Target, as defined by the user| |imageUrl |(String)| The URL pointing to the original, uncompressed and uncropped Target binary file| |thumbnailUrl| (String)| The URL pointing to a thumbnail representation of the Target| |rating |(Number)| The rating (from 0 to 3) of the Target| |fileSize |(Number)| The file size of the original Target binary image file, in bytes| |physicalHeight |(Number)| The physical (real world) height of the target, in millimeters| |creDat| (Number)| A timestamp when the Target was created (as returned by JavaScript's Date.now() function)| |modDat |(Number)| A timestamp when the Target was last modified (as returned by JavaScript's Date.now() function)| |metadata| (JSON)| Arbitrary JSON data that is stored together with the target.|   "
});

documentTitles["cloudrecognitionworkflow.html#generate-a-cloud-archive"] = "Generate a Cloud Archive";
index.add({
    url: "cloudrecognitionworkflow.html#generate-a-cloud-archive",
    title: "Generate a Cloud Archive",
    body: "## Generate a Cloud Archive  Once you are done with adding targets you need to tell the server that it should generate your TargetCollection into a Cloud Archive. Call  	/cloudrecognition/targetCollection/:tcId/generation 	 again with the `ID` of your TargetCollection and the process will be started. Since this call is asynchronous you will receive the response immediately with a path in the Location-property in the header of the response. By calling the url with the path, for example 	 	/cloudrecognition/targetCollection/:tcId/generation/wtc/:generationId 	 with a GET-method request, you will see the [status of the progress](cloudrecoapi://index.html#api-TargetCollection-GetGenerationInformation) of the cloud archive generation in the response body as a JSON object. When the generation is completed, the cloud archive is available for recognition. Note that the generation process can take a while when generating a large TargetCollection for the first time. Small additions to existing cloud archives are processed a lot faster.  &lt;div class=\&quot;warning\&quot;&gt; Everytime you changed a target (add/delete) you need to manually call Generate Cloud Archive for your target collection. Otherwise  &lt;ul&gt;&lt;li&gt;your newly added image will not be recognized &lt;/li&gt; &lt;li&gt;your deleted image will still be recognized&lt;/li&gt;&lt;/ul&gt;&lt;/div&gt;     Your Cloud Archive is now ready on the server and can be used in combination with the Wikitude SDK from your app. See the SDK sample called [Cloud Recognition](cloudrecognitionnative.html) for more details. "
});

documentTitles["cloudrecognitionworkflow.html#generate-a-wtc-file-via-api"] = "Generate a WTC file via API";
index.add({
    url: "cloudrecognitionworkflow.html#generate-a-wtc-file-via-api",
    title: "Generate a WTC file via API",
    body: "## Generate a WTC file via API You can create and download a wtc file of a Target Collection ([Generate WTC](cloudrecoapi://#api-TargetCollection-GenerateWTC)) with up to 1000 targets by calling  	/cloudrecognition/targetCollection/:tcId/generation/wtc 	 with method POST. You have to specify the SDK version the wtc file should be built for in the request body. Valid values for the version are `3.x`, `4.0`, `4.1`,  `5.0`,`5.1`,`5.2`,`5.3`,`6.0`. Optionally, an email address can be added. The email is used for a notification once the generation of the wtc file has finished. Example for the request body:  	{ 		\&quot;sdkVersion\&quot;: \&quot;6.0\&quot;, 		\&quot;iwantmywtcfile@wikitude-user.com\&quot; 	} 	 Similar to the cloud archive generation this call is asynchronous, so the response header (`Location`) contains a path useful for requesting the [status of the wtc creation](cloudrecoapi://index.html#api-TargetCollection-GetWTCGenerationInformation). Once the status is `COMPLETED` the link to the actual wtc file can be requested from the [TargetCollection](cloudrecoapi://#api-TargetCollection-GetTargetCollection). The received `TargetCollection` object (in the body of the response) contains an additional property called `wtc`, which is an array of wtc objects. Those objects consists of the following properties:  - the `url` to the wtc file,  - the number of targets (`nrOfTargets`), - the `version`, - the creation date (`creDat`)  "
});

documentTitles["cloudrecognitionworkflow.html#additional-calls"] = "Additional calls";
index.add({
    url: "cloudrecognitionworkflow.html#additional-calls",
    title: "Additional calls",
    body: "## Additional calls  Beside the above described steps the Manager API also offers to [Delete TargetCollections](cloudrecoapi://index.html#api-TargetCollection-DeleteTargetCollection) and [Delete Targets](cloudrecoapi://index.html#api-Target-DeleteTarget).   Using `GET` request you can query details about a [single TargetCollection](cloudrecoapi://#api-TargetCollection-GetTargetCollection), [all Target Collections](cloudrecoapi://#api-TargetCollection-GetAllTargetCollections) in your account, a [single Target](cloudrecoapi://#api-Target-GetTarget) and [all Targets within a TargetCollection](cloudrecoapi://#api-Target-GetAllTargets).  The physical height and the metadata of an existing target can be [updated](cloudrecoapi://#api-Target-UpdateTarget). "
});



documentTitles["migration-iosnative.html#migrate"] = "Migrate";
index.add({
    url: "migration-iosnative.html#migrate",
    title: "Migrate",
    body: "# Migrate  Migration notes for the Wikitude SDK Native API (iOS)  "
});

documentTitles["migration-iosnative.html#migrate-from-20-to-21"] = "Migrate from 2.0 to 2.1";
index.add({
    url: "migration-iosnative.html#migrate-from-20-to-21",
    title: "Migrate from 2.0 to 2.1",
    body: "## Migrate from 2.0 to 2.1 * [`WTNativeSDKStartupConfiguration`](iosnativeapi://Classes/WTNativeSDKStartupConfiguration.html) 	* new property [`targetRenderingAPI`](iosnativeapi://Classes/WTNativeSDKStartupConfiguration.html#//api/name/targetRenderingAPI)   * [`WTWikitudeNativeSDK`](iosnativeapi://Classes/WTWikitudeNativeSDK.html): 	* new method [`-registerPlugin:error:`](iosnativeapi://Classes/WTWikitudeNativeSDK.html#//api/name/registerPlugin:error:)  	* deprecated method [`-registerPlugin`](iosapi://Classes/WTWikitudeNativeSDK.html#//api/name/registerPlugin:)   "
});

documentTitles["migration-iosnative.html#migrate-from-14-to-20"] = "Migrate from 1.4 to 2.0";
index.add({
    url: "migration-iosnative.html#migrate-from-14-to-20",
    title: "Migrate from 1.4 to 2.0",
    body: "## Migrate from 1.4 to 2.0  * New protocol [`WTImageTrackerDelegate`](iosnativeapi://Protocols/WTImageTrackerDelegate.html) * New protocol [`WTInstantTrackerDelegate`](iosnativeapi://Protocols/WTInstantTrackerDelegate.html)  * New class [`WTAuthorizationRequestManager`](iosnativeapi://Classes/WTAuthorizationRequestManager.html) * New class [`WTTargetCollectionResource`](iosnativeapi://Classes/WTTargetCollectionResource.html) * New class [`WTCloudRecognitionService`](iosnativeapi://Classes/WTCloudRecognitionService.html) * New class [`WTImageTrackerConfiguration`](iosnativeapi://Classes/WTImageTrackerConfiguration.html) * New class [`WTImageTracker`](iosnativeapi://Classes/WTImageTracker.html) * New class [`WTImageTarget`](iosnativeapi://Classes/WTImageTarget.html) * New class [`WTInstantTracker`](iosnativeapi://Classes/WTInstantTracker.html) * New class [`WTInitializationPose`](iosnativeapi://Classes/WTInitializationPose.html) * New class [`WTInstantTarget`](iosnativeapi://Classes/WTInstantTarget.html) * New class [`WTNativeSDKStartupConfiguration`](iosnativeapi://Classes/WTNativeSDKStartupConfiguration.html)  * Deprecated class [`WTBaseTracker`](iosnativeapi://Classes/WTBaseTracker.html) * Deprecates class [`WTClientTracker`](iosnativeapi://Classes/WTClientTracker.html). Use [`WTTargetCollectionResource`](iosnativeapi://Classes/WTTargetCollectionResource.html) + [`WTImageTracker`](iosnativeapi://Classes/WTImageTracker.html) instead. * Deprecated class [`WTCloudTracker`](iosnativeapi://Classes/WTCloudTracker.html). Use [`WTCloudRecognitionService`](iosnativeapi://Classes/WTCloudRecognitionService.html) + [`WTImageTracker`](iosnativeapi://Classes/WTImageTracker.html) instead.  * [`WTWikitudeNativeSDK`](iosnativeapi://Classes/WTWikitudeNativeSDK.html): 	* New method [`+SDKBuildInformation`](iosnativeapi://Classes/WTImageTracker.html) 	* New method [`+resolveCaptureDeviceSettings:toSize:targetFrameRate:`](iosnativeapi://Classes/WTImageTracker.html)  * [`WTTrackerManager`](iosnativeapi://Classes/WTTrackerManager.html): 	* New method [`-createTargetCollectionResourceFromURL:completion`](iosnativeapi://Classes/WTImageTracker.html#//api/name/-createTargetCollectionResourceFromURL:completion) 	* New method [`-createCloudRecognitionService:completion`](iosnativeapi://Classes/WTImageTracker.html#//api/name/-createCloudRecognitionService:completion) 	* New method [`-createImageTrackerFromTargetCollectionResource:delegate:configuration:`](iosnativeapi://Classes/WTImageTracker.html#//api/name/-createImageTrackerFromTargetCollectionResource:delegate:configuration:) 	* New method [`-createImageTrackerFromCloudRecognitionService:delegate:configuration:`](iosnativeapi://Classes/WTImageTracker.html#//api/name/-createImageTrackerFromCloudRecognitionService:delegate:configuration:) 	* New method [`-createInstantTracker:delegate:configuration:`](iosnativeapi://Classes/WTImageTracker.html#//api/name/-createInstantTracker:delegate:configuration:) 	* Deprecated method [`-create2DClientTrackerFromURL:extededTargets:andDelegate:`](iosnativeapi://Classes/WTImageTracker.html#//api/name/-create2DClientTrackerFromURL:extededTargets:andDelegate:) 	* Deprecated method [`-create3DClientTrackerFromURL:andDelegate:`](iosnativeapi://Classes/WTImageTracker.html#//api/name/-create3DClientTrackerFromURL:andDelegate:) 	* Deprecated method [`-createCloudTrackerWithToken:targetCollectionId:extededTargets:andDelegate`](iosnativeapi://Classes/WTImageTracker.html#//api/name/-createCloudTrackerWithToken:targetCollectionId:extededTargets:andDelegate)  * [`WTCaptureDeviceManagerDelegate`](iosnativeapi://Protocols/WTCaptureDeviceManagerDelegate.html) 	* New property [`hasTorch`](iosnativeapi://Classes/WTCaptureDeviceManagerDelegate.html#//api/name/hasTorch) 	* New property [`cameraRenderingTargetTexture`](iosnativeapi://Classes/WTCaptureDeviceManagerDelegate.html#//api/name/cameraRenderingTargetTexture) 	  "
});

documentTitles["migration-iosnative.html#migrate-from-13-to-14"] = "Migrate from 1.3 to 1.4";
index.add({
    url: "migration-iosnative.html#migrate-from-13-to-14",
    title: "Migrate from 1.3 to 1.4",
    body: "## Migrate from 1.3 to 1.4 iOS 10 now requires a camera usage description. Please make sure that you add the `NSCameraUsageDescription` key to your applications .plist.  * [`WTWikitudeNativeSDK`](iosnativeapi://Classes/WTWikitudeNativeSDK.html)     * new [`-clearCache`](iosnativeapi://Classes/WTWikitudeNativeSDK.html#//api/name/-clearCache). Use this method to clear all internal SDK caches.   "
});

documentTitles["migration-iosnative.html#migrate-from-10-to-11"] = "Migrate from 1.0 to 1.1";
index.add({
    url: "migration-iosnative.html#migrate-from-10-to-11",
    title: "Migrate from 1.0 to 1.1",
    body: "## Migrate from 1.0 to 1.1 * [`WTTrackerManager`](iosnativeapi://Classes/WTTrackerManager.html)     * new [`-create2DClientTrackerFromURL:extendedTargets:andDelegate:`](iosnativeapi://Classes/WTTrackerManager.html#//api/name/-create2DClientTrackerFromURL:extendedTargets:andDelegate:) Use this method to create a new `WTClientTracker` object which is configured for 2D tracking.     * new [`-create3DClientTrackerFromURL:andDelegate:`](iosnativeapi://Classes/WTTrackerManager.html#//api/name/-create3DClientTrackerFromURL:andDelegate:) Use this method to create a new `WTClientTracker` object that is configured for 3D tracking.          * deprecated [`-createClientTrackerFromURL:extendedTargets:andDelegate:`]() Use [`-create2DClientTrackerFromURL:extendedTargets:andDelegate:`](iosnativeapi://Classes/WTTrackerManager.html#//api/name/-create2DClientTrackerFromURL:extendedTargets:andDelegate:) instead.  * new [`WTTrackingMapRecorder`](iosnativeapi://Classes/WTTrackingMapRecorder.html) Use this class to record and save so called 'Tracking Maps' that are needed for 3D tracking. "
});



documentTitles["referenceiosnative.html#reference"] = "Reference";
index.add({
    url: "referenceiosnative.html#reference",
    title: "Reference",
    body: "# Reference  "
});

documentTitles["referenceiosnative.html#ios-native-api-reference"] = "iOS Native API Reference";
index.add({
    url: "referenceiosnative.html#ios-native-api-reference",
    title: "iOS Native API Reference",
    body: "## iOS Native API Reference Go to [iOS  Reference](iosnativeapi://index.html) for a complete reference of all iOS Wikitude Native API objects and functions.  "
});

documentTitles["referenceiosnative.html#cloud-recognition-manager-api"] = "Cloud Recognition Manager API";
index.add({
    url: "referenceiosnative.html#cloud-recognition-manager-api",
    title: "Cloud Recognition Manager API",
    body: "## Cloud Recognition Manager API  Go to [REST API Reference](cloudrecoapi://index.html) for a complete reference of all REST API calls for the Manager API.    "
});



documentTitles["changelog.html#wikitude-sdk-ios-native-api-release-notes"] = "Wikitude SDK iOS Native API Release Notes";
index.add({
    url: "changelog.html#wikitude-sdk-ios-native-api-release-notes",
    title: "Wikitude SDK iOS Native API Release Notes",
    body: "# Wikitude SDK iOS Native API Release Notes  "
});

documentTitles["changelog.html#wikitude-sdk-native-api-210"] = "Wikitude SDK Native API 2.1.0";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-210",
    title: "Wikitude SDK Native API 2.1.0",
    body: "## Wikitude SDK Native API 2.1.0 Release Date: 28.03.2017  "
});

documentTitles["changelog.html#new"] = "New";
index.add({
    url: "changelog.html#new",
    title: "New",
    body: "#### New - Support for OpenGL ES 3.0 - New supported FrameColorSpace YV12 for input plugins - New plugin registration error callback that contains more information why an input plugin could not be registered - New Frame methods `hasStrides()` and `getFrameStrides()` to get stride information of frames provided by plugins  "
});

documentTitles["changelog.html#improved"] = "Improved";
index.add({
    url: "changelog.html#improved",
    title: "Improved",
    body: "#### Improved - Trial licenses now support instant tracking   "
});

documentTitles["changelog.html#wikitude-sdk-native-api-201"] = "Wikitude SDK Native API 2.0.1";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-201",
    title: "Wikitude SDK Native API 2.0.1",
    body: "## Wikitude SDK Native API 2.0.1 Release Date: 15.02.2017  "
});

documentTitles["changelog.html#fixed"] = "Fixed";
index.add({
    url: "changelog.html#fixed",
    title: "Fixed",
    body: "#### Fixed - Fixed a memory issue when instant tracking is used in combination with HD frame rendering (not recommended)   "
});

documentTitles["changelog.html#wikitude-sdk-native-api-200"] = "Wikitude SDK Native API 2.0.0";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-200",
    title: "Wikitude SDK Native API 2.0.0",
    body: "## Wikitude SDK Native API 2.0.0 Release Date: 25.01.2017  "
});

documentTitles["changelog.html#new"] = "New";
index.add({
    url: "changelog.html#new",
    title: "New",
    body: "#### New - The new instant tracking feature allows users to place augmentations without any markers in any surrounding. Instant tracking uses Wikitudes own SLAM-based 3D engine. - Added advanced camera settings like HD and 60 fps camera rendering and a manual focus control - Unified computer vision related class names  "
});

documentTitles["changelog.html#improved"] = "Improved";
index.add({
    url: "changelog.html#improved",
    title: "Improved",
    body: "#### Improved - Updated target collection format (.wtc) which improves the robustness and performance of 2D image recognition. - Extended tracking improved significant using the new SLAM technology  - Behaviour of removing plugins at runtime - lifecycle callbacks are now called properly - Plugins now receive a call to `surfaceChanged` in case the device was rotated while the application was not active.    "
});

documentTitles["changelog.html#wikitude-sdk-native-api-141"] = "Wikitude SDK Native API 1.4.1";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-141",
    title: "Wikitude SDK Native API 1.4.1",
    body: "## Wikitude SDK Native API 1.4.1 Release Date: 24.11.2016  "
});

documentTitles["changelog.html#fixed"] = "Fixed";
index.add({
    url: "changelog.html#fixed",
    title: "Fixed",
    body: "#### Fixed - Fixes an issue where cloud recognition did not work when using input plugins - Fixes a rare crash in the iOS Native SDK when 3D tracking is used - Fixes an issue where the Wikitude SDK camera stopped rendering in case an external AVCaptureSession instance was stopped   "
});

documentTitles["changelog.html#wikitude-sdk-native-api-140"] = "Wikitude SDK Native API 1.4.0";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-140",
    title: "Wikitude SDK Native API 1.4.0",
    body: "## Wikitude SDK Native API 1.4.0 Release Date: 13.09.2016  "
});

documentTitles["changelog.html#new"] = "New";
index.add({
    url: "changelog.html#new",
    title: "New",
    body: "#### New - Support for iOS 10 - New InputFrameRenderSettings options for Plugins API  "
});

documentTitles["changelog.html#fixed"] = "Fixed";
index.add({
    url: "changelog.html#fixed",
    title: "Fixed",
    body: "#### Fixed "
});

documentTitles["changelog.html#sdk"] = "SDK";
index.add({
    url: "changelog.html#sdk",
    title: "SDK",
    body: "###### SDK - Fixes issues with NAT64 networks  - Fixes a rare crash in the 3D Tracking engine  "
});

documentTitles["changelog.html#improved"] = "Improved";
index.add({
    url: "changelog.html#improved",
    title: "Improved",
    body: "#### Improved - Improved and aligned behaviour of cache handling - Improved and aligned behaviour of network handling for cloud recognition   "
});

documentTitles["changelog.html#wikitude-sdk-native-api-130"] = "Wikitude SDK Native API 1.3.0";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-130",
    title: "Wikitude SDK Native API 1.3.0",
    body: "## Wikitude SDK Native API 1.3.0 Release Date: 08.07.2016  "
});

documentTitles["changelog.html#new"] = "New";
index.add({
    url: "changelog.html#new",
    title: "New",
    body: "#### New - InputPlugins allow developer to use the Wikitude SDK with an external camera feed  "
});

documentTitles["changelog.html#fixed"] = "Fixed";
index.add({
    url: "changelog.html#fixed",
    title: "Fixed",
    body: "#### Fixed - Fixes an issue where destroying the SDK while a large .wtc file is loading, crashed the SDK - Fixes several issues that might lead to a crash if the SDK is paused/resumed - Fixes several issues that might lead to a crash if the SDK is destroyed and immediately afterwards created again - Fixes an issue where green camera frames could be rendered under certain circumstances - Fixes several issues where destroying the SDK might not release all of its allocated memory  "
});

documentTitles["changelog.html#wikitude-sdk-native-api-121"] = "Wikitude SDK Native API 1.2.1";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-121",
    title: "Wikitude SDK Native API 1.2.1",
    body: "## Wikitude SDK Native API 1.2.1 Release Date: 22.03.2016 (internal release only)  "
});

documentTitles["changelog.html#fixed"] = "Fixed";
index.add({
    url: "changelog.html#fixed",
    title: "Fixed",
    body: "#### Fixed - Unifies camera related API between Android and iOS  "
});

documentTitles["changelog.html#wikitude-sdk-native-api-120"] = "Wikitude SDK Native API 1.2.0";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-120",
    title: "Wikitude SDK Native API 1.2.0",
    body: "## Wikitude SDK Native API 1.2.0 Release Date: 01.12.2015  "
});

documentTitles["changelog.html#new"] = "New";
index.add({
    url: "changelog.html#new",
    title: "New",
    body: "#### New  - Support multiple regional co-located cloud recognition services  - Improvements in visualization of 3D Tracking Beta    "
});

documentTitles["changelog.html#wikitude-sdk-native-api-110"] = "Wikitude SDK Native API 1.1.0";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-110",
    title: "Wikitude SDK Native API 1.1.0",
    body: "## Wikitude SDK Native API 1.1.0 Release Date: 15.10.2015  "
});

documentTitles["changelog.html#new"] = "New";
index.add({
    url: "changelog.html#new",
    title: "New",
    body: "#### New  - 3D Tracking Beta for small-sized objects  - Map recorder in sample App  - Updated Client Tracking sample with new 3D Tracking sample  "
});

documentTitles["changelog.html#wikitude-sdk-native-api-100"] = "Wikitude SDK Native API 1.0.0";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-100",
    title: "Wikitude SDK Native API 1.0.0",
    body: "## Wikitude SDK Native API 1.0.0 Release Date: 28.08.2015  "
});

documentTitles["changelog.html#wikitude-sdk-native-api-100-beta"] = "Wikitude SDK Native API 1.0.0 beta";
index.add({
    url: "changelog.html#wikitude-sdk-native-api-100-beta",
    title: "Wikitude SDK Native API 1.0.0 beta",
    body: "## Wikitude SDK Native API 1.0.0 beta Release Date: 30.07.2015  "
});

documentTitles["changelog.html#new"] = "New";
index.add({
    url: "changelog.html#new",
    title: "New",
    body: "#### New - Initial Public Release of iOS Native API "
});

