//
//  SimpleYUVInputPlugin.hpp
//  DevApplication
//
//  Created by Andreas Schacherbauer on 10/03/16.
//  Copyright © 2016 Wikitude. All rights reserved.
//

#ifndef SimpleYUVInputPlugin_hpp
#define SimpleYUVInputPlugin_hpp

#include <atomic>
#include <chrono>
#include <mutex>
#include <string>
#include <list>

#include <WikitudeNativeSDK/InputPlugin.h>
#include <WikitudeNativeSDK/RecognizedTarget.h>


@class WTSimpleDeviceCamera;

class SimpleYUVInputPlugin : public wikitude::sdk::InputPlugin {
    
public:
    SimpleYUVInputPlugin(__weak WTSimpleDeviceCamera* camera_);
    virtual ~SimpleYUVInputPlugin();

    // from Plugin
    void initialize();
    void pause();
    void resume(unsigned int pausedTime_);
    void destroy();

    // from InputPlugin
    bool requestsInputFrameRendering();
    bool requestsInputFrameProcessing();
    bool allowsUsageByOtherPlugins();

    void notifyNewImageBufferData(std::shared_ptr<unsigned char> imageBufferData);
    
protected:
    long                            _frameId;
    __weak WTSimpleDeviceCamera*    _camera;

    bool                            _initialized;
    bool                            _running;
};

#endif /* SimpleYUVInputPlugin_hpp */
